<?php
	if (!defined("ENV")) exit();
	if( !ini_get('safe_mode') )
		set_time_limit(10000);
	
	if ($settings["USE_MOD_REWRITE"]=="YES")
	{
		require_once("content/engine/engine_url_rewrite.php");	
	}
	else
	{
		require_once("content/engine/engine_url_default.php");
	}
	
	$export_format = "rss";//isset($export_format)?$export_format:"rss";
	
	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new DB_TREE_NODE(TREE_ROOT, -1, 0, "Yes", "Category Root"));
	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	while($db->moveNext()){
		$tree->addNode(
			new DB_TREE_NODE(
				$db->col["cid"], 
				$db->col["parent"], 
				$db->col["level"], 
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}
	
	function fr_normalize($s){
		$ss = str_replace("\r", " ", $s);
		$ss = str_replace("\n", " ", $ss);
		$ss = str_replace("\t", " ", $ss);
		$ss = str_replace("\0", " ", $ss);
		$ss = htmlentities(trim(stripslashes($ss)));
		$sss = "";
		$whitespace = false;
		for($i=0; $i<strlen($ss); $i++){
			$sss = $sss.((($ss[$i] == " " && !$whitespace) || ($ss[$i] != " ")) ? $ss[$i] : "");
			$whitespace = $ss[$i] == " ";
		}
		return $sss;
	}
	
	function st_normalize($string){
		$string_final = strip_tags($string);
		$string_final = htmlspecialchars($string_final);
		return utf8_encode($string_final);
	} 
	
	function getCategoryPath($id){
		global $tree;
		$path = "";
		$_id = $id;
		for($i=0; $i<count($tree->collection); $i++){
			$path = (fr_normalize(str_replace(">", " ", $tree->collection[$_id]->caption))).($path==""?"":" > ").$path;
			$_id = $tree->collection[$_id]->parent_id;
			if(!($_id > 0)){
				break;
			}
		}
		return $path;
	}


	if(!checkdate($_POST["expmonth"],$_POST["expday"],$_POST["expyear"])) {
		$expdate = gmdate("Y-m-d");	
	} else {
		$expdate = gmdate("Y-m-d", mktime(0,0,0,$_POST["expmonth"],$_POST["expday"],$_POST["expyear"]));
	}
	$service_type = (!isset($service_type) || trim($service_type) == "") ? "Not Define":$service_type;
	$de = isset($de)?trim($de):"overview";

	//Store location from the Company Information
	$db->query("SELECT * FROM ".DB_PREFIX."settings WHERE visible='Yes'  AND group_id='1' ORDER BY priority");
	$store_location = "";
	while($db->moveNext()){
		$address[$db->col["name"]] = $db->col["value"]; 
	}
	$store_location = trim($address["CompanyAddressLine1"])==""?"":$address["CompanyAddressLine1"];
	$store_location = $store_location.(trim($address["CompanyAddressLine2"])==""?"":", ".$address["CompanyAddressLine2"]);
	$store_location = $store_location.(trim($address["CompanyCity"])==""?"":", ".$address["CompanyCity"]);
	$store_location = $store_location.(trim($address["CompanyState"])==""?"":", ".$address["CompanyState"]);
	$store_location = $store_location.(trim($address["CompanyZip"])==""?"":", ".$address["CompanyZip"]);
	$store_location = $store_location.(trim($address["CompanyCountry"])==""?"":", ".$address["CompanyCountry"]);

	if($export_format == "rss"){
		$mime_type = "text/xml";
		$filename = "froogle";
		$ext = "xml";
	}
	else{
		$mime_type = "text/plain";
		$filename = "froogle";
		$ext = "txt";
	}
	
	header('Content-Type: '.$mime_type);
	header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
	header('Content-Disposition: inline; filename="'.$filename.'.'.$ext.'"');
	header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	header('Content-Disposition: attachment; filename="'.$filename.'.'.$ext.'"');
	header('Pragma: no-cache');
	
	// initialize $ms array
	$ms = array();
	
	$db->query("SELECT ".DB_PREFIX."manufacturers.manufacturer_id AS id, ".DB_PREFIX."manufacturers.manufacturer_name FROM ".DB_PREFIX."manufacturers");	
	while($db->moveNext()) { 
		$ms[$db->col["id"]] = $db->col["manufacturer_name"];
	}
	
	
	
	$db->query("
		SELECT ".DB_PREFIX."products.*, 
		IF(".DB_PREFIX."products.url_custom = '', ".DB_PREFIX."products.url_default, ".DB_PREFIX."products.url_custom) AS product_url,
		".DB_PREFIX."catalog.name AS cat_name  
		FROM ".DB_PREFIX."products INNER JOIN ".DB_PREFIX."catalog ON ".DB_PREFIX."products.cid = ".DB_PREFIX."catalog.cid 
		WHERE ".DB_PREFIX."products.is_visible='Yes' AND ".DB_PREFIX."products.call_for_price='No' 
		ORDER BY title");

	if($export_format == "rss"){
		echo '<?xml version="1.0" encoding="UTF-8"?>'."\r\n";
		echo '<rss version="2.0" xmlns:g="http://base.google.com/ns/1.0">'."\r\n";
		echo '<channel>'."\r\n";
		echo '<title>'.$settings["GlobalSiteName"].'</title>'."\r\n";
		echo '<link>'.$settings["GlobalHttpUrl"].'</link>'."\r\n";
		echo '<description>'.$settings["GlobalSiteName"].' Products</description>'."\r\n";
	}
	else{
		echo "link\ttitle\tdescription\tprice\timage_link\r\n";
	}
	$imageTypes = array( "jpg", "gif", "jpeg", "png");
	while($db->moveNext()){
		if($export_format == "rss"){
			$product_url = getProductUrl($db->col["product_url"], $db->col["pid"], $db->col["cid"]);
			$name = $db->col["title"];
			$pid = $db->col["product_id"];
			$upc = $db->col["product_upc"];
			$weight = $db->col["weight"];

			// Newly added variables.
			$brand = (array_key_exists($db->col["manufacturer_id"], $ms)) ? $ms[$db->col["manufacturer_id"]] : null;
			$brand = is_null($brand) || empty($brand) ? "Unknown" : $brand;
			$condition = "New";
			$producttype = $db->col["cat_name"];
			// end add 

			switch($de){
				case "description" : $_description = $db->col["description"]; break;
				case "overview" : $_description = trim($db->col["overview"])==""?$db->col["title"]:$db->col["overview"]; break;
			}
			$description = trim($_description)==""?$name:$_description;
			$description = str_replace("!", ".",$description);
			$description = str_replace("  ", "", $description);			
			
			$price = (intval($db->col['case_pack']) > 0)
				? $db->col["price"] * $db->col['case_pack']
				: $db->col["price"];
			
			$image_url = "";
			if($db->col["image_location"] == "Web" && $db->col["image_url"] != ""){
				$image_url = $db->col["image_url"];
			}
			else{
				foreach($imageTypes as $ext) {
					if(file_exists($settings["GlobalServerPath"]."/images/products/".$db->col["product_id"].".".$ext)) {
						$image_url = fr_normalize($settings["GlobalHttpUrl"]."/images/products/".$db->col["product_id"] . "." . $ext); //normalize again
						break;
					}
					elseif(file_exists($settings["GlobalServerPath"]."/images/products/".strtolower($db->col["product_id"]).".".$ext)) {
						$image_url = fr_normalize($settings["GlobalHttpUrl"]."/images/products/".strtolower($db->col["product_id"]).".".$ext);
						break;
					}
				}
			}
			$image_url = trim($image_url)== ""?fr_normalize($settings["GlobalHttpUrl"]."/images/images/english/imageNoImageBig.gif"):$image_url;
			
			echo "<item>\r\n";
			echo "<title>".st_normalize($name)."</title>\r\n";
			echo "<link>".st_normalize($product_url)."</link>\r\n";
			echo "<description>".st_normalize($description)."</description>\r\n";
			echo "<g:id>".st_normalize($pid)."</g:id>\r\n";
			echo "<g:upc>".st_normalize($upc)."</g:upc>\r\n";
			echo "<g:image_link>".st_normalize($image_url)."</g:image_link>\r\n";
			echo "<g:price>".st_normalize(number_format($price, 2, ".", ""))."</g:price>\r\n";
			
			if ($weight > 0) echo "<g:weight>".st_normalize($upc.($settings["LocalizationWeightUnits"] == "kg" ? " kg" : " lb"))."</g:weight>\r\n";

			//added for google base ver
			echo "<g:brand>".st_normalize($brand)."</g:brand>\r\n";
			echo "<g:condition>".st_normalize($condition)."</g:condition>\r\n";
			echo "<g:product_type>".st_normalize($producttype)."</g:product_type>\r\n";
			//echo "<g:service_type>".st_normalize($service_type)."</g:service_type>\r\n";
			echo "<g:location>".st_normalize($store_location)."</g:location>\r\n";
			echo "<g:expiration_date>".st_normalize($expdate)."</g:expiration_date>\r\n";

			//end added
			echo "</item>\r\n";
			
		}
		else{
			$product_url = fr_normalize(getProductUrl($db->col["product_url"], $db->col["pid"], $db->col["cid"]));
			$name = substr(fr_normalize($db->col["title"]), 0, 80);
			switch($de){
				case "description" : $_description = $db->col["description"]; break;
				case "overview" : $_description = trim($db->col["overview"])==""?$db->col["description"]:$db->col["overview"]; break;
			}
			$description = substr(fr_normalize($_description), 0, 1000);
			$price = fr_normalize($db->col["price"]);
			foreach($imageTypes as $ext) {
				if(file_exists($settings["GlobalServerPath"]."/images/products/". $db->col["product_id"] . "." . $ext)) {
					$image_url = fr_normalize($settings["GlobalHttpUrl"]."/images/products/".$db->col["product_id"] . "." . $ext); //normalize again
					break;
				}
			}
			if(isset($image_url) && $image_url != "") {
				echo $product_url."\t".$name."\t".$description."\t".number_format($price, 2, ".", "")."\t".$image_url."\r\n";
			}
		}
		unset($image_url);
	}
	
	if($export_format == "rss"){
		echo '</channel>'."\r\n";
		echo '</rss>'."\r\n";
	}
?>
