<?php

if (!defined("ENV")) exit();

if (_ACCESS_ALL || _ACCESS_ATTRIBUTES)
{
	$mode = isset($mode)?trim($mode):"";
	$gaid = isset($gaid)?intval($gaid):"";
	$name = isset($name)?trim($name):"";
	$caption = isset($caption)?trim($caption):"";
	$priority = isset($priority)?trim($priority):5;	
	$categories = isset($categories)?$categories:array();
	$is_active = isset($is_active)?$is_active:"No";
	$update_mode = isset($update_mode)?trim($update_mode):"save";
	
	$attribute_type = isset($attribute_type)?$attribute_type:"select";
	if ($attribute_type=="select") $options = isset($options)?trim($options):"";
	if ($attribute_type=="radio") $options = isset($options_radio)?trim($options_radio):"";
	$text_length = isset($text_length)?intval($text_length):"20";
	
	//update or insert attribute data
	
	$db->reset();
	$db->assignStr("is_global", in_array("global", $categories)?"Yes":"No");
	$db->assignStr("is_active", $is_active);
	$db->assignStr("priority", $priority);
	$db->assignStr("name", $name);
	$db->assignStr("caption", $caption);
	$db->assignStr("options", $options);
	$db->assignStr("attribute_type", $attribute_type);
	$db->assignStr("text_length", $text_length);
		
	if ($mode == "insert")
	{
		if (!DEMO_LOCK)
		{
			$gaid = $db->insert(DB_PREFIX."global_attributes");
		}
		else
		{
			$gaid = 0;
		}
		$message_mode = "insert";
	}
	else if ($mode=="update")
	{
		if (!DEMO_LOCK)
		{
			$db->update(DB_PREFIX."global_attributes", "WHERE gaid='".$gaid."'");
		}
		$message_mode = "update";
	}
	else
	{
		$message_mode = "incorrect";
	}
	
	
	//do products-specific changed
	if (($mode == "insert" || $mode == "update"))
	{
		$is_modifier = false;
		if ($attribute_type == "select" || $attribute_type == "radio")
		{
			$opt = explode("\n", $options);
			for ($oc=0; $oc < count($opt); $oc++)
			{
				if (preg_match("/^.+\(\s*([+-]?)\s*((\d+)|(\d+\.\d+))\s*([%]?)\s*((\,([+-]?)\s*((\d+)|(\d+\.\d+))\s*([%]?))?)\s*\)\s*$/", $opt[$oc]))
				{
					$is_modifier = true;
				}
			}
		}
	
		//update categories
		$db->query("DELETE FROM ".DB_PREFIX."catalog_attributes WHERE gaid='".$gaid."'");
		reset($categories);
		$where = "";
		if (!in_array("global", $categories))
		{
			//build categories select query
			reset($categories);
			foreach ($categories as $num=>$cid)
			{
				if (!DEMO_LOCK) $db->query("INSERT INTO ".DB_PREFIX."catalog_attributes VALUES(".$cid.", ".$gaid.")");
				$where .= ($where!=""?" OR ":"")." ".DB_PREFIX."products.cid='".$cid."'";
			}
		}
		//mode
		switch ($update_mode)
		{
			case "rewrite" :
			{
				// select products for selected categories or all products for global
				$db->query("SELECT pid FROM ".DB_PREFIX."products ".(($where=="")?"":" WHERE (".$where.")"));
				// store ids into array
				$ids = array();
				while ($db->moveNext())
				{
					$ids[] = $db->col["pid"];
				}
				// update attribute for selected products
				for ($i=0; $i<count($ids); $i++)
				{
					// remove product attribute first for update action
					if ($mode=="update")
					{
						if (!DEMO_LOCK) $db->query("DELETE FROM ".DB_PREFIX."products_attributes WHERE pid='".$ids[$i]."' AND gaid='".$gaid."'");
					}
					$db->reset();
					$db->assignStr("attribute_type", $attribute_type);
					$db->assignStr("pid", $ids[$i]);
					$db->assignStr("gaid", $gaid);
					$db->assignStr("priority", $priority);
					$db->assignStr("is_active", $is_active);
					$db->assignStr("is_modifier", $is_modifier);
					$db->assignStr("name", $name);
					$db->assignStr("caption", $caption);
					$db->assignStr("text_length", $text_length);
					$db->assignStr("options", $options);
					if (!DEMO_LOCK) $db->insert(DB_PREFIX."products_attributes");
				}
				break;
			}
			
			case "reassign" :
			{
				// select products for selected categories or all products for global
				// but skip products where attributes already exist
				$db->query("
					SELECT ".DB_PREFIX."products.* FROM ".DB_PREFIX."products 
					LEFT JOIN ".DB_PREFIX."products_attributes ON ".DB_PREFIX."products_attributes.pid = ".DB_PREFIX."products.pid AND ".DB_PREFIX."products_attributes.gaid='".$gaid."'
					WHERE ".DB_PREFIX."products_attributes.gaid IS NULL ".(($where=="")?"":" AND (".$where.")")
				);
				// store ids into array
				$ids = array();
				while ($db->moveNext())
				{
					$ids[count($ids)] = $db->col["pid"];
				}
				// update attribute for selected products
				for ($i=0; $i<count($ids); $i++)
				{
					$db->reset();
					$db->assignStr("attribute_type", $attribute_type);
					$db->assignStr("pid", $ids[$i]);
					$db->assignStr("gaid", $gaid);
					$db->assignStr("priority", $priority);
					$db->assignStr("is_active", $is_active);
					$db->assignStr("is_modifier", $is_modifier);
					$db->assignStr("name", $name);
					$db->assignStr("caption", $caption);
					$db->assignStr("text_length", $text_length);
					$db->assignStr("options", $options);
					if (!DEMO_LOCK) $db->insert(DB_PREFIX."products_attributes");
				}
				break;
			}
			
			case "convert" :
			{
				if (!DEMO_LOCK) 
				{
					$db->query("UPDATE ".DB_PREFIX."products_attributes SET gaid=0 WHERE gaid='".$gaid."'");
					$db->query("DELETE FROM ".DB_PREFIX."catalog_attributes WHERE gaid='".$gaid."'");
					$db->query("DELETE FROM ".DB_PREFIX."global_attributes WHERE gaid='".$gaid."'");
				}
				$message_mode = "convert";
				break;
			}
			
			case "delete" :
			{
				if (!DEMO_LOCK)
				{
					$db->query("DELETE FROM ".DB_PREFIX."products_attributes WHERE gaid='".$gaid."'");
					$db->query("DELETE FROM ".DB_PREFIX."catalog_attributes WHERE gaid='".$gaid."'");
					$db->query("DELETE FROM ".DB_PREFIX."global_attributes WHERE gaid='".$gaid."'");
				}
				$message_mode = "delete";
				break;
			}
		}
	}
	else
	{
		if ($mode == "delete")
		{
			if (!DEMO_LOCK)
			{
				$db->query("DELETE FROM ".DB_PREFIX."products_attributes WHERE gaid='".$gaid."'");
				$db->query("DELETE FROM ".DB_PREFIX."catalog_attributes WHERE gaid='".$gaid."'");
				$db->query("DELETE FROM ".DB_PREFIX."global_attributes WHERE gaid='".$gaid."'");
			}
			$message_mode = "delete";
		}
	}
	
	switch ($message_mode)
	{
		case "insert" : 
		{
			pageHeader("Attribute Created", "", "ic_attribute.gif");
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"<b>New attribute has been successfully created</b>", "url"=>"", "visible"=>true)
			));
			pageWhat(array(
				array("icon"=>"ic_change_text.gif", "text"=>"Edit just created attribute", "url"=>"admin.php?p=products_attribute&mode=update&gaid=".$gaid),
				array("icon"=>"ic_insert_row.gif", "text"=>"Add new attribute again", "url"=>"admin.php?p=products_attribute&mode=insert"),
				array("icon"=>"", "text"=>"Browse attributes", "url"=>"admin.php?p=products_attributes")
			));
			break;
		}
		case "update" :
		{
			pageHeader("Attribute Updated", "", "ic_attribute.gif");
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"<b>Attribute has been successfully updated</b>", "url"=>"", "visible"=>true)
			));
			pageWhat(array(
				array("icon"=>"ic_change_text.gif", "text"=>"Back to attribute editing", "url"=>"admin.php?p=products_attribute&mode=update&gaid=".$gaid),
				array("icon"=>"ic_insert_row.gif", "text"=>"Add new attribute", "url"=>"admin.php?p=products_attribute&mode=insert"),
				array("icon"=>"", "text"=>"Browse attributes", "url"=>"admin.php?p=products_attributes")
			));
			break;
		}
		case "convert" :
		{
			pageHeader("Attribute Remove From List", "", "ic_attribute.gif");
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"<b>Attribute has been removed from global attributes list and converted to \"Product-specific\"</b>", "url"=>"", "visible"=>true)
			));
			pageWhat(array(
				array("icon"=>"ic_insert_row.gif", "text"=>"Add new attribute", "url"=>"admin.php?p=products_attribute&mode=insert"),
				array("icon"=>"", "text"=>"Browse attributes", "url"=>"admin.php?p=products_attributes")
			));
			break;
		}
		case "delete" :
		{
			pageHeader("Attribute Removed", "", "ic_attribute.gif");
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"<b>Attribute has been successfully removed</b>", "url"=>"", "visible"=>true)
			));
			pageWhat(array(
				array("icon"=>"", "text"=>"Browse attributes", "url"=>"admin.php?p=products_attributes"),
				array("icon"=>"ic_insert_row.gif", "text"=>"Add new attribute", "url"=>"admin.php?p=products_attribute&mode=insert")
			));
			break;
		}
	}
	if (!DEMO_LOCK)
	{
		$db->query("SELECT ".DB_PREFIX."products.pid FROM ".DB_PREFIX."products INNER JOIN ".DB_PREFIX."products_attributes ON ".DB_PREFIX."products.pid=".DB_PREFIX."products_attributes.pid GROUP BY ".DB_PREFIX."products.pid");
		$r = $db->getRecords();
		for ($i=0; $i<count($r); $i++)
		{
			updateProductAttributesCount($db, $r[$i]["pid"]);
		}
	}
}
else
{
	pageHeader("Global Product Attribute", "", "ic_attribute.gif");
	pageNote(array(
		array("icon"=>"ic_hint.gif", "text"=>"<b>This feature is not available under your license agreement. Please contact your provider to upgrade your application.</b>", "url"=>"", "visible"=>true)
	));
}
