<?php

	require_once("content/classes/class.products_locations.php");

	$productsLocations = new ProductsLocations($db);

	pageHeader("Products Locations");

	$lastTab = isset($_REQUEST["lastTab"]) ? $_REQUEST["lastTab"] : "Locations";
	$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : "";
	$message = "";
	
	if ($action == "delete" && !DEMO_LOCK)
	{
		$productsLocationId = isset($_REQUEST["products_location_id"]) ? intval($_REQUEST["products_location_id"]) : 0;
		$productsLocations->delete($productsLocationId);
		$message = "Selected product locatoin has been removed";
	}

	if ($action == "updateSettings" && !DEMO_LOCK)
	{
		$ProductsLocationsSendOption = isset($_POST["ProductsLocationsSendOption"]) ? $_POST["ProductsLocationsSendOption"] : "admin";
		$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($ProductsLocationsSendOption)."' WHERE name='ProductsLocationsSendOption'");
		$settings["ProductsLocationsSendOption"] = $ProductsLocationsSendOption;
		$message = "Products locations settings are updated";
	}

	pageNote(
		array(
			array("icon"=>"ic_insert_row.gif","url"=>"admin.php?p=products_location&mode=new","text"=>"Create new product location", "visible"=>true),
			array("icon"=>"ic_hint.gif","url"=>"","text"=>"<b>".$message."</b>", "visible"=>$message!="")
		)
	);

	$locations = $productsLocations->getAll();

	pageTabs(array(
		array("title"=>"Locations", "id"=>"Locations", "active"=>$lastTab == "Locations", "width"=>110),
		array("title"=>"Settings", "id"=>"Settings", "active"=>$lastTab == "Settings", "width"=>110)
	));
?>
<div id="idTabSheetLocations" class="clearfix sheet<?=$lastTab=="Locations"?"Active":"Unactive"?>">
	<script type="text/javascript" src="content/admin/javascript/products_locations.js"></script>
	<table width="100%" cellpadding="0" cellspacing="5" border="0">
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_change_text.gif"></div>
				<div class="formHeaderText">Your Current Locations</div>
			</td>
		</tr>
	</table>
	<div style="padding:5px;margin-left:6px;" class="clearfix">
	<div class="listHeader">
		<div class="listHeaderIcon"><img src="images/icons/ic_globe.gif"/></div>
		<div class="listHeaderCaption" style="width:200px;">Location Name</div>
		<div class="listHeaderCaption" style="width:100px;">Type</div>
		<div class="listHeaderCaption" style="width:100px;">Status</div>
		<div class="listHeaderCaption" style="width:200px;">Contact Person</div>
	</div>

<?php
	if ($locations && count($locations) > 0)
	{
		foreach ($locations as $location)
		{
?>
	<div class="listItem">
		<div class="listItemIcon"><img src="images/icons/ic_home.gif"/></div>
		<div class="listItemText" style="width:200px;"><a href="admin.php?p=products_location&mode=update&products_location_id=<?=$location["products_location_id"]?>"><?=htmlspecialchars($location["name"])?></a></div>
		<div class="listItemText" style="width:100px;"><?=ucfirst(htmlspecialchars($location["location_type"]))?></div>
		<div class="listItemText" style="width:100px;"><?=ucfirst(htmlspecialchars($location["is_active"] ? "Active" : "Disabled"))?></div>
		<div class="listItemText" style="width:200px;"><a href="mailto:<?=$location["contact_email"]?>"><?=htmlspecialchars($location["contact_name"])?></a></div>
		<div class="listItemButtons">
			<a href="admin.php?p=products_location&mode=update&products_location_id=<?=$location["products_location_id"]?>"><img src="images/icons/ic_change_text.gif" border="0" title="Edit Page"></a>
			<a href="javascript:ConfirmDeleteProductsLocation(<?=$location["products_location_id"]?>)"><img src="images/icons/ic_delete.gif" border="0" title="Delete Location"></a>
		</div>
	</div>
<?php
		}
	}
	else
	{
?>
	<div class="listEmpty">
		No product locations have been entered yet.
	</div>
<?
	}
?>
	</div>
</div>
<div id="idTabSheetSettings" class="sheet<?=$lastTab=="Settings"?"Active":"Unactive"?>">
<form action="admin.php?p=products_locations" method="post">
	<input type="hidden" name="action" value="updateSettings"/>
	<input type="hidden" name="lastTab" value="Settings"/>
	<table width="100%" cellpadding="0" cellspacing="5" border="0">
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_change_text.gif"></div>
				<div class="formHeaderText">Settings</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">
				When do you want to send notifications?
				<div class="formItemComment">
					To edit notification email template <a href="admin.php?p=email_notification&id=products_location_notification">please click here</a>.
				</div>
			</td>
			<td class="formItemControl">
				<input type="radio" name="ProductsLocationsSendOption" id="ProductsLocationsSendOptionAdmin" value="admin" <?=$settings["ProductsLocationsSendOption"]=="admin"?"checked":""?>/><label for="ProductsLocationsSendOptionAdmin">When administrator confirmed order and set status to "Completed"</label><br/>
				<input type="radio" name="ProductsLocationsSendOption" id="ProductsLocationsSendOptionUser" value="user" <?=$settings["ProductsLocationsSendOption"]=="user"?"checked":""?>/><label for="ProductsLocationsSendOptionUser">When payment received from user (including situation when administrator set payment status to "Received")</label><br/>
				<input type="radio" name="ProductsLocationsSendOption" id="ProductsLocationsSendOptionOff" value="off" <?=$settings["ProductsLocationsSendOption"]=="off"?"checked":""?>/><label for="ProductsLocationsSendOptionOff">Turn off this feature</label><br/>
			</td>
		</tr>
	</table>
	<div class="formButtons">
		<input type="submit" value="Save Changes">
	</div>
</form>
</div>

