<?php
	if (!defined("ENV")) exit();

	$auth_ok = false;

	/**
	 * Check does admin session exist
	 */
	if (isset($_SESSION["admin_session_id"]) && isset($_SESSION["admin_auth_id"]) && isset($_SESSION["admin_auth_time"]))
	{
		$admin_session_id = $_SESSION["admin_session_id"];
		$admin_auth_id = $_SESSION["admin_auth_id"];
		$admin_auth_time = $_SESSION["admin_auth_time"];
		
		/**
		 * In admin mode only check admin id
		 */
		if (DEMO_MODE && DEMO_LOCK)
		{
			//demo access
			$query = "SELECT *, NOW() as now FROM ".DB_PREFIX."admins WHERE aid='".intval($admin_auth_id)."'";
		}
		/**
		 * Or check everything
		 */
		else
		{
			/**
			 * Check IP restriction (if applicable)
			 */
			if (trim($settings['SecurityAdminIps']) != '')
			{
				$wildcard_tag = '*';
				$user_ip = str_replace('.', ',', $_SERVER['REMOTE_ADDR']);
				$user_ip_array = explode(',', $user_ip);
				$restricted_ips = explode(',', trim($settings['SecurityAdminIps']));
				$found_ip = false;
				
				foreach ($restricted_ips as $ip)
				{
					$pattern_array = $user_ip_array;
					$ip = str_replace('.', ',', $ip);
					$ip_array = explode(',', $ip);
					// check if the pattern already matches and break out of loop for optimization
					if ($pattern_array === $ip) { $found_ip = true; break; }
					$ip = str_replace($wildcard_tag, '[0-9]{1,3}', $ip);
					if (eregi($ip, $user_ip)) { $found_ip = true; break; }
				}
				
				if (($settings['SecurityAdminIpRestriction'] == 'Allow' && !$found_ip) || ($settings['SecurityAdminIpRestriction'] == 'Deny' && $found_ip))
				{
					print '<h1 style="font-family: Verdana; font-weight: normal; font-size: 14px;">Your IP address has been blocked</h1>';
					session_destroy();
					die();
				}
				
				unset($pattern_array, $user_ip_array, $wildcards);
			}
			
			/**
			 * Check http-https url
			 */
			if ($settings["SecurityAdminAreaMode"] == "HTTPS" && $_SERVER['SERVER_PORT'] != "443")
			{
				$auth_https_warning = true;
			}
			
			/**
			 * Check admin timeout
			 */
		
			$expiration_time = $admin_auth_time + intval($settings["SecurityAdminTimeOut"]) * 60;
			$current_time = time();
			
			if ($current_time > $expiration_time)
			{
				unset($_SESSION["admin_session_id"]);
				unset($_SESSION["admin_auth_id"]);
				unset($_SESSION["admin_auth_time"]);
				unset($_SESSION["admin_design_mode"]);  
				session_write_close();
				header("Location: login.php");
				die();
			}
			else
			{
				$_SESSION["admin_auth_time"] = $current_time;
			}
			
			/**
			 * Check access
			 */
			$query = "
				SELECT *, NOW() as now 
				FROM ".DB_PREFIX."admins 
				WHERE 
					session_id LIKE BINARY '".$db->escape($admin_session_id)."' 
					AND aid='".intval($admin_auth_id)."' 
					AND active='Yes'
			";
		}
		
		//run query
		$db->query($query);
		
		if($db->moveNext())
		{
			$admin = $db->col;
			$auth_ok = true;
			// authorize tinymce access
			$_SESSION['admin_tinymce_auth_ok'] = true;
			
			$admin_auth_id = $admin["aid"];
			$auth_rights = explode(",", $admin["rights"]);
			$auth_admin_username = $admin["username"];
			$auth_admin_name = $admin["name"];
			$auth_admin_email = $admin["email"];
			
			$db->query("UPDATE ".DB_PREFIX."admins SET last_access=NOW() WHERE aid='".intval($admin_auth_id)."'");
			
			//set app restrictions based on iono level

			define("_ACCESS_LEVEL", $iono->level);											//1, 2, 3, 99
			
			define("_ACCESS_ALL", $iono->level == 1);										//1, 0, 0, 0
			define("_ACCESS_CCS", $iono->level == 1);										//1, 0, 0, 0
			
			define("_ACCESS_UPS", $iono->level >= 1 || $iono->level == 99);					//1, 1, 1, 1
			define("_ACCESS_USPS", $iono->level <= 2 || $iono->level == 99);				//1, 1, 0, 1
			define("_ACCESS_FEDEX", $iono->level == 1 || $iono->level == 99);				//1, 0, 0, 1
			define("_ACCESS_CANADA_POST", $iono->level == 1 || $iono->level == 99);			//1, 0, 0, 1
			
			define("_ACCESS_ATTRIBUTES", $iono->level <= 2 || $iono->level == 99);			//1, 1, 0, 1
			define("_ACCESS_INVENTORY", $iono->level <= 2 || $iono->level == 99);			//1, 1, 0, 1
			define("_ACCESS_DOWNLOADS", $iono->level == 1 || $iono->level == 99);			//1, 0, 0, 1
			define("_ACCESS_RECOMMENDED", $iono->level <= 2 || $iono->level == 99);			//1, 1, 0, 1
			
			define("_ACCESS_MULTIPLE_ADMINS", $iono->level == 1 || $iono->level == 99);		//1, 0, 0, 1
			define("_ACCESS_FLAT_URL", $iono->level <= 2 || $iono->level == 99);			//1, 1, 0, 1
			
			define("_ACCESS_PAYPAL_IPN", $iono->level >= 1 || $iono->level == 99);			//1, 1, 1, 0
			define("_ACCESS_PAYPAL_PRO", $iono->level <= 2 || $iono->level != 99);			//1, 1, 0, 0 // for trial paypal_all overrides this option
			define("_ACCESS_PAYPAL_ALL", $iono->level == 1 || $iono->level == 99);			//1, 0, 0, 1
			define("_ACCESS_PAYPAL_LIVE", $iono->level != 99);								//1, 1, 1, 0
			define("_ACCESS_WORLDPAY", $iono->level >= 1 || $iono->level != 99);			//1, 1, 1, 0
			define("_ACCESS_AUTHORIZE", $iono->level <= 2 || $iono->level != 99);			//1, 1, 0, 0
			
			define("_ACCESS_GOOGLE_CHECKOUT", $iono->level <= 2 || $iono->level != 99);		//1, 1, 0, 0
			
			define("_ACCESS_FILEMANAGER", $iono->level != 99);								//1, 1, 1, 0
			
			/**
			 * if required, force admin to change password after 90 days
			 */
			if ($settings["SecurityForceCompliantAdminPasswords"] == "YES")
			{
				$password_age = (strtotime($admin["now"]) - strtotime($admin["last_update"])) / 86400; // in days
				if ($password_age > 90)
				{
					//force admin to change password
					if (!in_array($p, array("profile", "profile_process")))
					{
						header("Location: admin.php?p=profile");
					}
					$auth_force_change_password = true;
				}
			}
		}
	}
	
	function IsPrivilege($a, $rights){
		$r = false;
		for($i=0; $i<count($a); $i++){
			if(in_array($a[$i], $rights)){
				$r = true;
			}
		}
		return $r;
	}
	
	if(!$auth_ok){
		$q = "?";
		reset($_GET);
		foreach($_GET as $name=>$value){
			$q.="&".$name."=".$value;
		}
		header("Location: ".$settings["GlobalHttpUrl"]."/login.php?&q=".urlencode($q));
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<title><?=$label_app_name?> Administrator Area Security Error</title>
	<link rel="stylesheet" href="styles/admin.css" type="text/css">
</head>
<body topmargin="0" leftmargin="0" marginwidth="0" marginheight="0" bgcolor="white">
&nbsp;<p>
<div class="h4" align="center">
	<div class="h3">Security Error</div>
	Please click <a href="login.php">here</a> and login again.
</div>
</body>
<?
	}
?>