<?php 
define("ORDER_ADD_GIFT_CERT", "AddGiftCert");
	
class GiftCertificates {
	public $db = false;
	public $is_error = false;
	public $errors = array();

	// set error message
	function setError($str)
	{
		$this->errors[count($this->errors)] = $str;
	}

	// constructor
	function GiftCertificates(&$db)
	{
		$this->db = $db;
		return $this;
	}

	// generate a voucher code
	function GenerateVoucher()
	{
		$voucher = '';
		for ($i=0; $i < 15; $i++)
		{
			$voucher .= rand(0, 9);
		}
		return $voucher;
	}

	function GetOrderedGiftCertById($ocid)
	{
		if ($ocid*1 < 1)
		{
			return false;
		}
		else
		{
			$this->db->query("SELECT * FROM ".DB_PREFIX."ordered_gift_cert WHERE ocid=".intval($ocid));
			if ($this->db->moveNext())
			{
				$order = $this->db->col;
				return $order;
			}
			else
			{
				return false;
			}
		}
	}

	function GetOrderedGiftCert($first_name, $last_name, $voucher)
	{
		$this->db->query("SELECT * FROM ".DB_PREFIX."ordered_gift_cert WHERE first_name='".$this->db->escape($first_name)."' AND last_name='".$this->db->escape($last_name)."'
		AND voucher='".$this->db->escape($voucher)."' AND balance>0");
		if ($this->db->moveNext())
		{
			$order = $this->db->col;
			return $order;
		}
		else
		{
			return false;
		}
	}

	function GetOrderGiftCert($oid)
	{
		if ($oid*1 < 1)
		{
			return false;
		}
		else
		{
			$this->db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid=".$this->db->escape($oid));
			if ($this->db->moveNext())
			{
				$order = $this->db->col;
	
				if ($order['gift_cert_first_name'] != '' && $order['gift_cert_last_name'] != '' && $order['gift_cert_voucher'] != '')
				{
					$order['gift_cert_valid'] = '1';
				}
				else
				{
					$order['gift_cert_valid'] = '0';
				}
	
				return $order;
			}
			else
			{
				return false;
			}
		}
	}

	function SetOrderGiftCert($oid, $first_name, $last_name, $voucher) {
		if (intval($oid) < 1)
		{
			return false;
		}
		else
		{
			$this->db->reset();
			$this->db->assignStr("gift_cert_first_name", $first_name);
			$this->db->assignStr("gift_cert_last_name", $last_name);
			$this->db->assignStr("gift_cert_voucher", $voucher);
			
			$this->db->update(DB_PREFIX."orders", "WHERE oid = ".$this->db->escape($oid));
			
			return true;
		}
	}

	function GetGiftCertificate($oid)
	{
		if (intval($oid) < 1)
		{
			return false;
		}
		else
		{
			$this->db->query("SELECT ".DB_PREFIX."orders_gift_cert.* FROM ".DB_PREFIX."orders_gift_cert 
			INNER JOIN ".DB_PREFIX."orders_content ON ".DB_PREFIX."orders_content.oid = ".DB_PREFIX."orders_gift_cert.oid AND
			".DB_PREFIX."orders_content.ocid = ".DB_PREFIX."orders_gift_cert.ocid WHERE ".DB_PREFIX."orders_gift_cert.oid=".$this->db->escape($oid));
			if ($this->db->moveNext())
			{
				$order = $this->db->col;
	
				return $order;
			}
			else
			{
				return false;
			}
		}
	}

	function GetGiftCertificates($where_balance = '')
	{
		$this->db->query("SELECT ".DB_PREFIX."ordered_gift_cert.* , ".DB_PREFIX."orders_gift_cert.message , 
								".DB_PREFIX."orders_gift_cert.email, ".DB_PREFIX."orders_gift_cert.phone  
				    	  FROM ".DB_PREFIX."ordered_gift_cert 
			              LEFT JOIN ".DB_PREFIX."orders_gift_cert ON ".DB_PREFIX."orders_gift_cert.ocid = ".DB_PREFIX."ordered_gift_cert.ocid
						  $where_balance ORDER BY date_ordered");
		if ($this->db->numRows() > 0)
		{
			$list = $this->db->getRecords();
			return $list;
		}
		return false;		
	}
	
	function DeleteGiftCertificate($gift_cert)
	{
		if ($gift_cert['ocid']*1 < 1)
		{
			return false;
		}
		else {
			$this->db->query("DELETE FROM ".DB_PREFIX."ordered_gift_cert WHERE ocid=".intval($this->db->escape($gift_cert['ocid'])));
		
			return true;
		}
	}

	function UpdateGiftCertificate($gift_cert)
	{
		if ($gift_cert['ocid']*1 < 1)
		{
			return false;
		}
		else
		{
			if ($gift_cert['first_name'] == '') {
				$this->setError("Complete first name");
			}
			if ($gift_cert['last_name'] == '') {
				$this->setError("Complete last name");
			}
			if ($gift_cert['voucher'] == '') {
				$this->setError("Complete voucher");
			}
			
			$this->is_error = count($this->errors)>0;

			if (!$this->is_error) {
				$this->db->reset();
				$this->db->assignStr("first_name", $gift_cert['first_name']);
				$this->db->assignStr("last_name", $gift_cert['last_name']);
				$this->db->assignStr("balance", $gift_cert['balance']);
				$this->db->assignStr("voucher", $gift_cert['voucher']);
				
				$this->db->update(DB_PREFIX."ordered_gift_cert", "WHERE ocid=".intval($gift_cert['ocid']));
			}
			
			return !$this->is_error;
		}
	}

	function OrderGiftCertificate($ocid, $first_name, $last_name, $balance, $voucher)
	{
		$this->db->query("SELECT * FROM ".DB_PREFIX."ordered_gift_cert WHERE ocid='".intval($ocid)."'");
		if($this->db->moveNext()){
			return;
		}
		$this->db->reset();
		$this->db->assignStr("ocid", $ocid);
		$this->db->assignStr("first_name", $first_name);
		$this->db->assignStr("last_name", $last_name);
		$this->db->assignStr("balance", $balance);
		$this->db->assignStr("voucher", $voucher);
		$this->db->assign("date_ordered", "now()");
		
		$this->db->insert(DB_PREFIX."ordered_gift_cert");
	}

	function SendNotification($oid)
	{
		global $settings;
	
		$gift_cert = $this->GetGiftCertificate($oid);
		if ($gift_cert === false)
		{
			return false;
		}

		view()->assign('voucher', $gift_cert['voucher']);
		view()->assign('gift_amount', $gift_cert['gift_amount']);
		view()->assign('first_name', $gift_cert['first_name']);
		view()->assign('last_name', $gift_cert['last_name']);
		view()->assign('from_name', $gift_cert['from_name']);
		view()->assign('message', $gift_cert['message']);
		
		$message_user = view()->fetch("templates/emails/gift_cert_html.html");
		
		set_time_limit(300);
		//send email to user
		send_mail($gift_cert['email'], stripslashes($settings["CompanyName"]." - A Gift Certificate For You!"), $message_user, "", 'html');
	}

	// add new gift certificate to the cart
	function AddGiftCertificate($order, $first_name, $last_name, $phone, $email, $gift_amount, $from_name, $message, $email_gift)
	{
		global $settings;
		$this->db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id='gift_certificate' AND is_visible='Yes'");
		
		if($this->db->moveNext()){
			$product = $this->db->col;
			
			$gift_data = $this->GetGiftCertificate($order->oid);
			
			$this->db->reset();
			$this->db->assign("oid", $order->oid);
			$this->db->assign("pid", $product['pid']);
			$this->db->assignStr("price", $gift_amount);
			$this->db->assignStr("admin_price", $gift_amount);
			$this->db->assign("quantity", '1');
			$this->db->assign("admin_quantity", '1');
			$this->db->assignStr("is_taxable", 'No');
			$this->db->assignStr("free_shipping", 'Yes');
			$this->db->assignStr("product_id", $product["product_id"]);
			$this->db->assignStr("title", $product["title"]);

			if ($gift_data === false) {
				$ocid = $this->db->insert(DB_PREFIX."orders_content");
			} else {
				$ocid = $gift_data['ocid'];
				$this->db->update(DB_PREFIX."orders_content", "WHERE ocid=".intval($ocid));
			}

			$voucher = $this->GenerateVoucher();

			$this->db->reset();
			$this->db->assign("oid", intval($order->oid));
			$this->db->assignStr("first_name", $first_name);
			$this->db->assignStr("last_name", $last_name);
			$this->db->assignStr("phone", $phone);
			$this->db->assignStr("email", $email);
			$this->db->assign("gift_amount", floatval($gift_amount));
			$this->db->assignStr("from_name", $from_name);
			$this->db->assignStr("message", $message);
			$this->db->assignStr("voucher", $voucher);
			$this->db->assign("email_gift", $email_gift);

			if ($gift_data === false) {
				$this->db->assign("ocid", $ocid);
				$gcid = $this->db->insert(DB_PREFIX."orders_gift_cert");
			} else {
				$this->db->update(DB_PREFIX."orders_gift_cert", "WHERE ocid=".intval($ocid));
			}

			return true;
		}
		else{
			$this->setError("Error ocurred while adding gift certificate to the cart");
			return false;
		}
	}

	// update gift certificate balance
	function UpdateBalance($oid, $ocid, $balance)
	{

		$this->db->reset();
		$this->db->assign("balance", "balance-".floatval($balance));
		$this->db->update(DB_PREFIX."ordered_gift_cert", "WHERE ocid=".intval($ocid));

		$this->db->reset();
		$this->db->assign("gift_cert_amount", floatval($balance));
		$this->db->update(DB_PREFIX."orders", "WHERE oid=".intval($oid));

		return true;
	}
	
	function UpdateOrderGCAmount($oid, $balance)
	{
		$this->db->reset();
		$this->db->assign("gift_cert_amount", floatval($balance));
		$this->db->update(DB_PREFIX."orders", "WHERE oid=".intval($oid));
		return true;
	}
}
