<?php
/**
 * Process payment
 */	

if (!defined("ENV")) exit();

if ($user->auth_ok && $order->itemsCount > 0)
{
	$payment = new PAYMENT($db);

	if ($payment->isMethods() && $payment->isMethod($order->paymentMethodId))
	{
		$pm = $payment->methods[$order->paymentMethodId];
			
		// custom payment methods
		if(trim($pm->id) != "")
		{
			$gate = $payment->methods[$order->paymentMethodId];
			$gateway_id = escapeFileName($gate->id);
			@require_once("content/engine/payment/payment_".($gateway_id).".php");
			//create instance of payment processor (gateway) class
			unset($pp);
			@eval("\$pp = new ".$payment_processor_class."();");
				
			//set to true by defalt
			$is_payment_error = true;

			if (isset($pp) && is_object($pp))
			{
				$order->getShippingAddress();
				$pp->db_id = $order->paymentMethodId;
				$pp->protocol = $pm->protocol;
				$pp->getSettingsData($db);
				$pp->getCommonData($user, $order);
				
				if ($pp->steps == 1)
				{
					//return entered values of background
					//orders processing
					$form = isset($_POST["form"]) ? $_POST["form"] : array();
					$form = is_array($form) ? $form : array();
				}
				else
				{
					//return POST VARS passed by 
					//payment gateway
					$form = $_REQUEST;
				}
					
				if ($result = $pp->process($db, $user, $order, $form))
				{
					// *** GIFT CERTIFICATE
					$gift_cert = new GiftCertificates($db);
					$gift_data = $gift_cert->GetGiftCertificate($order->oid);
					if ($gift_data !== false)
					{
						// the user has ordered a gift certificate
						$gift_cert->OrderGiftCertificate($gift_data['ocid'], $gift_data['first_name'], $gift_data['last_name'], $gift_data['gift_amount'], $gift_data['voucher']);
						if ($gift_data['email_gift'] == '1')
						{
							$gift_cert->SendNotification($order->oid);	
						}
					}
					$gift_cert_amount = 0;
					$total_amount = $order->totalAmount; //-$order->shippingAmount-$order->taxAmount-($order->handlingSeparated?$order->handlingAmount:0.00);

					if ($total_amount > 0)
					{
						$gift_cert = new GiftCertificates($db);
						$order_data = $gift_cert->GetOrderGiftCert($order->oid);
						if ($order_data['gift_cert_valid'] == '1')
						{
							$gift_data = $gift_cert->GetOrderedGiftCert($order_data['gift_cert_first_name'], $order_data['gift_cert_last_name'], $order_data['gift_cert_voucher']);
								
							if ($gift_data !== false)
							{
								$balance = $gift_data['balance'];
								if ($total_amount > $balance)
								{
									$gift_cert_amount = $balance;
									$gift_cert->UpdateBalance($order->oid, $gift_data['ocid'], $balance);
								}
								else
								{
									$gift_cert_amount = $total_amount;
									$gift_cert->UpdateBalance($order->oid, $gift_data['ocid'], $total_amount);
								}
							}
						}
					}
					
					if ($gift_cert_amount > 0)
					{
						$db->reset();
						$db->assignStr("payment_method_name", "Gift Certificate");
						$db->assignStr("payment_gateway_id", "");
						$db->update(DB_PREFIX."orders", "WHERE oid='".$order->oid."'");
						view()->assign("payment_method_name", "Gift Certificate");
					}
					view()->assign("gift_cert_amount", $gift_cert_amount);
					// *** GIFT CERTIFICATE
					$is_payment_error = false;
					
					unset($_SESSION["payment_session_delay_timeout"]);
					
					if (is_bool($result))
					{
						$payment_status = "Received";
					}
					else
					{
						if (in_array($result, array("Pending", "Received")))
						{
							$payment_status = $result;
						}
						else 
						{
							$payment_status = "Received";
						}
					}
					// fix for http://dev.pinnaclecart.com/mantis/view.php?id=76
					if ($order->totalAmount == 0)
					{
						$payment_status = "Received";
					}
					
					if (($settings["InventoryStockUpdateAt"]=="Payment Received" && $payment_status == "Received") || $settings["InventoryStockUpdateAt"]=="Order Placed")
					{
						$order->stockControl(); //do not process stock without payment
					}

					$order->order_num = $order->closeOrder($order->shippingDigital?"Completed":"Process", $payment_status);
						
					///////////////////////////////////////
					// BUY SAFE
					if ($settings["buysafe_active"] == "Yes")
					{
						$buysafe = new BuySafeAPI($settings);
						$result = $buysafe->setShoppingCartCheckout($user, $order, $db);
					}
					
					///////////////////////////////////////
					// DOBA
					if (isset($_SESSION["doba_items_in_order"]) && $_SESSION["doba_items_in_order"] && $settings["doba_autosend_orders"] == "Yes")
					{
						$doba_items = array();
						foreach ($order->items as $item)
						{
							if ($item["is_doba"] == "Yes") $doba_items[] = array("item_id"=>$item["product_id"], "quantity"=>$item["quantity"]);
						}
						if (count($doba_items) > 0)
						{
							require_once("content/classes/class.doba_order.php");
							$dobaOrder = new DobaOrderAPI($settings, $db);
							
		 					$doba_order_response = $dobaOrder->createOrder($order->shippingAddress, $doba_items);
		 	
						 	if ($doba_order_response)
		 					{
		 						$db->query("UPDATE ".DB_PREFIX."orders SET doba_order_sent=1, doba_order_id='".$db->escape($doba_order_response["order_id"][0])."' WHERE oid='".$order->oid."'");
		 					}
						}
					}
					unset($_SESSION["doba_items_in_order"]);
					
					////////////////////////////////////////
					// Send notifications
					emailOrderReceived($db, $order, $user, $custom_fields, $payment_status);
					
					// Drop Shipping
					if($payment_status == "Received" && $settings["ProductsLocationsSendOption"] == "user")
					{
						emailProductsLocationsNotify($db, $order->oid);
					}
						
					if ($pp->id != "paypalipn")
					{
						$backurl = $url_dinamic."pcsid=".session_id()."&p=completed";
					}
					else
					{
						die();
					}
				}
			}
						
			if ($is_payment_error)
			{
				$payment->is_error = true;
				$payment->error_message = (isset($pp) && $pp) ? $pp->error_message : "Critical error: Could not create gateway class instance. Please contact to site administrator.";
				
				////////////////////////////////////////////
				// Check is engine set to block users accounts
				// Possible cc hack protection
				if ($settings["SecurityAccountBlocking"] == "YES")
				{
					if (!$order->attempt($settings["SecurityAccountBlockingAttempts"]))
					{
						$user->block($settings["SecurityAccountBlockingHours"]);
						$user->logOut();
						$order->newCart(0);
						$backurl = $url_dinamic."p=blocked";
					}
				}
			}
		}
	}
}