<?php 

	if (!defined("ENV")) exit();

	$reupdateOrderItems = false;
	
	// create/restore user info
	$user = new USER($db, $settings);
	
	// ua - user action
	$ua = isset($_REQUEST["ua"]) ? $_REQUEST["ua"] : "";
	if ($ua != "")
	{
		switch($ua)
		{
			case USER_EXPRESS_CHECKOUT : require_once("content/engine/actions/action.user_express_checkout.php"); break;
			case USER_SIGNUP : require_once("content/engine/actions/action.user_signup.php"); break;
			case USER_PASSWORD_RESET : require_once("content/engine/actions/action.user_password_reset.php"); break;
			case USER_LOGIN :  require_once("content/engine/actions/action.user_login.php"); break;
			case USER_UPDATE_PROFILE : require_once("content/engine/actions/action.user_update_profile.php"); break;
			case USER_ADD_ADDRESS : require_once("content/engine/actions/action.user_add_address.php"); break;
			case USER_UPDATE_ADDRESS : require_once("content/engine/actions/action.user_update_address.php"); break;
			case USER_DELETE_ADDRESS : require_once("content/engine/actions/action.user_delete_address.php"); break;
			case USER_LOGOUT : require_once("content/engine/actions/action.user_logout.php"); break;
			case USER_FORM_MAIL : require_once("content/engine/actions/action.user_form_mail.php"); break;
			case USER_START_CHECKOUT : require_once("content/engine/actions/action.user_start_checkout.php"); break;
			case USER_ADD_TO_WISHLIST : require_once("content/engine/actions/action.user_addto_wishlist.php"); break;
		}
		$reupdateOrderItems = true;
	}
	
	// get user data second time after possible changes
	$user->getUserData();
	
	// create/restore, check & process order's action
	$oa = isset($_REQUEST["oa"]) ? $_REQUEST["oa"] : "";
	$order = new ORDER($db, $settings, $user, $oa != "");
	
	if($user->auth_ok && $settings["TaxAddress"] != "Default"){
		if($settings["TaxAddress"] == "Billing"){
			$order->taxCountryId = $user->data["country"];
			$order->taxStateId = $user->data["state"];
		}
		$order->checkShippingDigital();
		if($settings["TaxAddress"] == "Shipping" && !$order->shippingDigital && $order->oid > 0 && $order->oid != ""){
			$sa = $order->getShippingAddress();
			if($sa && $order->shippingAddress["country_id"] > 0){
				$order->taxCountryId = $sa["country_id"];
				$order->taxStateId = $sa["state_id"];
			}
		}
	}
	
	// select order data first time before possible modification
	$order->getOrderData();
	$order->getOrderItems();
		
	if($oa != ""){	
		// oa - order action
		switch($oa){
			// *** GIFT CERTIFICATE
			case ORDER_ADD_GIFT_CERT : require_once("content/engine/actions/action.order_add_gift_cert.php"); break;
			// *** GIFT CERTIFICATE		
			case ORDER_ADD_ITEM : require_once("content/engine/actions/action.order_add_item.php"); break;
			case ORDER_REMOVE_ITEM : require_once("content/engine/actions/action.order_remove_item.php"); break;
			case ORDER_CLEAR_ITEMS : require_once("content/engine/actions/action.order_clear_items.php"); break;
			case ORDER_RE_UPDATE_ITEMS : require_once("content/engine/actions/action.order_reupdate_items.php"); break;
			case ORDER_CHECK_PROMO : require_once("content/engine/actions/action.order_check_promo.php"); break;
			case ORDER_CONTINUE_SHOPPING :
			case ORDER_UPDATE_ITEMS : 
			case ORDER_ONE_PAGE_CHECKOUT :
			case ORDER_BILLING_AND_SHIPPING_ADDRESS : require_once("content/engine/actions/action.order_update_items.php"); break;
			case ORDER_UPDATE_BILLING_AND_SHIPPING_ADDRESS : require_once("content/engine/actions/action.order_update_billing_and_shipping_address.php"); break;
			case ORDER_STORE_PAYPAL_EC_INFO : require_once("content/engine/actions/action.order_store_paypal_ec_info.php"); break;
			case ORDER_UPDATE_SHIPPING_METHOD : require_once("content/engine/actions/action.order_update_shipping_method.php"); break;
			case ORDER_COMPLETE_ORDER : require_once("content/engine/actions/action.order_complete_order.php"); break;
			case ORDER_PROCESS_PAYMENT_VALIDATION : require_once("content/engine/actions/action.order_process_payment_validation.php"); break;
			case ORDER_PROCESS_PAYMENT : require_once("content/engine/actions/action.order_process_payment.php"); break;
			case ORDER_WISHLIST_TO_CART : require_once("content/engine/actions/action.order_wishlist_to_cart.php"); break;
		}
	
		if($user->auth_ok && $settings["TaxAddress"] != "Default"){
			if($settings["TaxAddress"] == "Billing"){
				//$user->getUserData();
				$order->taxCountryId = $user->data["country"];
				$order->taxStateId = $user->data["state"];
			}
			$order->checkShippingDigital();
			if($settings["TaxAddress"] == "Shipping" && !$order->shippingDigital){
				$sa = $order->getShippingAddress();
				if($order->shippingAddress["country_id"] > 0){
					$order->taxCountryId = $order->shippingAddress["country_id"];
					$order->taxStateId = $order->shippingAddress["state_id"];
				}
			}
		}
		
		if($oa != ORDER_PROCESS_PAYMENT && $oa != ORDER_COMPLETE_ORDER){
			$order->getOrderData();
			$order->getOrderItems();
		}
		$reupdateOrderItems = true;
	}
	
	/**
	 * In case of possible changes reupdate items
	 */
	if ($reupdateOrderItems)
	{
		$order->reupdateItems();
		$order->recalcOrderData();
	}
	
	/////////////////////////////////////////
	// BUY SAFE
	if($settings["buysafe_active"] == "Yes" &&
		(
			in_array($oa, array(ORDER_ADD_GIFT_CERT, ORDER_ADD_ITEM, ORDER_REMOVE_ITEM, ORDER_CLEAR_ITEMS, ORDER_RE_UPDATE_ITEMS, ORDER_UPDATE_ITEMS, ORDER_WISHLIST_TO_CART)) ||
			in_array($p, array("cart"))
		)
	)
	{
		$buySafe = new BuySafeAPI($settings);
		view()->assign("buySafe", $buySafe->addUpdateShoppingCart($user, $order, $db));
		$order->getOrderData();
	}
	
	$order->getTaxRates();
	
	// GOOGLE BUTTON in cart box and on cart page
	if($order->totalAmount > 0){	
		$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE id='googlecheckout' AND active='Yes'");		
		if($db->moveNext()){
			@require_once("content/engine/payment/payment_googlecheckout.php");
			$payment_gateway = new PAYMENT_GOOGLECHECKOUT();
			
			$pf = $payment_gateway->getPaymentForm($db, array(), array());			
			$payment_gateway->isTestMode();
			$post_url = $payment_gateway->getPostUrl();

			view()->assign("google_checkout_active", true);
			view()->assign("google_title", $payment_gateway->name);			
			view()->assign("google_url", $post_url);
			if(!$payment_gateway->allow_checkout){
				$bt_variant = "disabled";
				view()->assign("google_not_allowed", $msg["cart"]["google_button_disable"]);	
			}
			else
				$bt_variant = "text";
			if(strlen(trim($settings["googlecheckout_google_checkout_button_size"])) > 0){
				$buttone_bg = $settings["googlecheckout_google_checkout_button_background"] != ""?($settings["googlecheckout_google_checkout_button_background"] == "White"?"white":"trans") : "white";
				$button_size_value = explode  ("-", $settings["googlecheckout_google_checkout_button_size"]);
				if(count($button_size_value)>1){$button_size = explode("x", trim($button_size_value[1]));}
				if(count($button_size)>1)
					$google_buton_url = "https://checkout.google.com/buttons/checkout.gif?merchant_id=".$settings["googlecheckout_Merchant_ID"]."&w=".$button_size[0]."&h=".$button_size[1]."&style=".$buttone_bg."&variant=".$bt_variant."&loc=en_".$settings["googlecheckout_your_location"];
				else
					$google_buton_url = "https://checkout.google.com/buttons/checkout.gif?merchant_id=".$settings["googlecheckout_Merchant_ID"]."&w=160&h=43&style=white&variant=".$bt_variant."&loc=en_US";		
			
			}
			else
				$google_buton_url = "https://checkout.google.com/buttons/checkout.gif?merchant_id=".$settings["googlecheckout_Merchant_ID"]."&w=160&h=43&style=white&variant=".$bt_variant."&loc=en_US";
			view()->assign("google_buton_url", $google_buton_url);					
			view()->assign("google_signature", $pf[0]);
			view()->assign("google_cart", $pf[1]);					
		}
		else{
			view()->assign("google_checkout_active", false);
		}
	}
	// -------------

	if (isset($_GET['killsession'])) { session_destroy(); die(); }

