<?php 

	define("TREE_ROOT", 0);
	class DB_TREE_NODE{
		var $id;
		var $parent_id;
		var $level;
		var $caption;
		var $is_visible;
		var $nodes;
		var $children;
		var $url;
		function DB_TREE_NODE($id, $parent_id, $level, $is_visible, $caption, $url = ""){
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			$this->is_visible = $is_visible;
			$this->caption = $caption;
			$this->url = $url;
			$this->nodes = array();
			$this->children = array();
			return $this;
		}
		
		//
		function scanChildren2(&$t, &$parent){
			reset($t->nodes);
			while(list($id, $node) = each($t->nodes)){
				$parent->children[$id] = $node;
				//echo $id."; ";
				$node->scanChildren2($node, $parent);
			}
		}
			
		function scanChildren(){
			$this->scanChildren2($this, $this);
		}
		
		
		// by default param = node level
		function drawNode($param){
			for($i=0; $i<($level*5); $i++){
				echo "&nbsp;";
			}
			echo $this->caption."<br>";
			reset($this->nodes);
			while(list($id, $node) = each($this->nodes)){
				$node->drawNode($param+1);
			}
		}
	}
	
	class DB_TREE{
		var $collection;
		///////////////////////////////////////////////
		//function: add new node to collection
		function addNode($node){
			$this->collection[$node->id] = &$node;
			$this->collection[$node->parent_id]->nodes[$node->id] = &$node;
		}
		
		///////////////////////////////////////////////
		//constructor: creates new tree object instance
		function DB_TREE(){
			$this->collection = array();
			return $this;
		}
	}

