<?php 

class UPS { 
    var $server = ""; 
    var $tracking_server = "";
    var $user = ""; 
    var $pass = ""; 
    var $service = ""; 
    var $dest_zip; 
    var $orig_zip; 
    var $pounds; 
    var $ounces; 
    var $container = "None"; 
    var $size = "REGULAR"; 
    var $machinable; 
	var $to_country;
	var $from_country;
	var $pickupType;
	var $accessKey;
	var $weightUnit;
	var $lengthUnit;
	var $residential;
	var $customerClassification;
	
    function setServer($server) { 
        $this->server = $server; 
    } 
    
    function setTrackingServer($server) { 
        $this->tracking_server = $server; 
    } 
    
    function setAccessKey($AccessKey) { 
        $this->accessKey = $AccessKey; 
    } 

    function setUserName($user) { 
        $this->user = $user; 
    } 

    function setPass($pass) { 
        $this->pass = $pass; 
    } 

    function setService($service) { 
        /* Must be: Express, Priority, or Parcel */ 
        $this->service = $service; 
    } 
    
	function setPickupType($pickupType){
		$this->pickupType = $pickupType;
		if($pickupType ==11){
			$this->customerClassification ="<CustomerClassification>
       												<Code>04</Code>
   											</CustomerClassification>";
		}
		else 
			$this->customerClassification ="";
	}

	function setCountry($toCountry,$fromCountry){
		$this->to_country = $toCountry;
		$this->from_country = $fromCountry;
	}

    function setDestZip($sending_zip) { 
        /* Must be 5 digit zip (No extension) */ 
        $this->dest_zip = $sending_zip; 
    } 

    function setOrigZip($orig_zip) { 
        $this->orig_zip = $orig_zip; 
    } 

    function setWeight($pounds, $ounces=0) { 
        /* Must weight less than 70 lbs. */ 
	 	if($pounds < 1 && $pounds > 0) $pounds = 1;
        $this->pounds = $pounds; 
        $this->ounces = $ounces; 
    } 
    
    function setWeightUnit($weightUnit) { 
        $this->weightUnit = $weightUnit; 
    }
     
    function setLengthUnit($lengthUnit) { 
        $this->lengthUnit = $lengthUnit; 
    }
    

    function setContainer($cont) { 
        /* 
        Valid Containers 
                Package Name             Description 
        Express Mail 
                None                For someone using their own package 
                0-1093 Express Mail         Box, 12.25 x 15.5 x 
                0-1094 Express Mail         Tube, 36 x 6 
                EP13A Express Mail         Cardboard Envelope, 12.5 x 9.5 
                EP13C Express Mail         Tyvek Envelope, 12.5 x 15.5 
                EP13F Express Mail         Flat Rate Envelope, 12.5 x 9.5 

        Priority Mail 
                None                For someone using their own package 
                0-1095 Priority Mail        Box, 12.25 x 15.5 x 3 
                0-1096 Priority Mail         Video, 8.25 x 5.25 x 1.5 
                0-1097 Priority Mail         Box, 11.25 x 14 x 2.25 
                0-1098 Priority Mail         Tube, 6 x 38 
                EP14 Priority Mail         Tyvek Envelope, 12.5 x 15.5 
                EP14F Priority Mail         Flat Rate Envelope, 12.5 x 9.5 
         
        Parcel Post 
                None                For someone using their own package 
        */ 

        if ($cont=="00") {
         $this->container='<PackagingType>'.
				'<Code>'.urlencode($cont).'</Code>'.
			     '</PackagingType>';
								
        }
        else{
        	 $this->container='<PackagingType>'.
									'<Code>'.urlencode($cont).'</Code>'.
								'</PackagingType>';
        }
    } 
    
    function setResidential($flag){
    	If($flag>0)
    		$this->residential='<ResidentialAddressIndicator/>';
    	
    }

    function setSize($size) { 
        /* Valid Sizes 
        Package Size                Description        Service(s) Available 
        Regular package length plus girth     (84 inches or less)    Parcel Post 
                                        Priority Mail 
                                        Express Mail 

        Large package length plus girth        (more than 84 inches but    Parcel Post 
                            not more than 108 inches)    Priority Mail 
                                        Express Mail 

        Oversize package length plus girth   (more than 108 but        Parcel Post 
                             not more than 130 inches) 

        */ 
        $this->size = $size; 
    } 

   // function setMachinable($mach) { 
        /* Required for Parcel Post only, set to True or False */ 
  //      $this->machinable = $mach; 
  //  } 
     
    function getShippingRate() { 
    	global $settings;
    	// may need to urlencode xml portion 
        $str = '<?xml version="1.0"?>'.
        			'<AccessRequest xml:lang="en-US">'.
        				'<AccessLicenseNumber>'.urlencode($this->accessKey).'</AccessLicenseNumber>'.
						 '<UserId>'.urlencode($this->user).'</UserId>'.
						 '<Password>'.urlencode($this->pass).'</Password>'.
					'</AccessRequest>'.
				'<?xml version="1.0"?>'.
					'<RatingServiceSelectionRequest xml:lang="en-US">'.
						'<Request>'.
							'<TransactionReference>'.
								'<CustomerContext>Bare Bones Rate Request</CustomerContext>'.
								'<XpciVersion>1.0001</XpciVersion>'.
							'</TransactionReference>'.
							'<RequestAction>Rate</RequestAction>'.
							'<RequestOption>Rate</RequestOption>'.
						'</Request>'.
						'<PickupType>'.
							'<Code>'.urlencode($this->pickupType).'</Code>'.
						'</PickupType>'.
						'<Shipment>'.
							'<Shipper>'.
								'<Address>'.
									'<PostalCode>'.urlencode($this->orig_zip).'</PostalCode>'.
									'<CountryCode>'.urlencode($this->from_country).'</CountryCode>'.
								'</Address>'.
							'</Shipper>'.
							'<ShipTo>'.
								'<Address>'.
									'<PostalCode>'.urlencode($this->dest_zip).'</PostalCode>'.
									'<CountryCode>'.urlencode($this->to_country).'</CountryCode>'.
									$this->residential.
								'</Address>'.
							'</ShipTo>'.
							'<ShipFrom>'.
								'<Address>'.
									'<PostalCode>'.urlencode($this->orig_zip).'</PostalCode>'.
									'<CountryCode>'.urlencode($this->from_country).'</CountryCode>'.
								'</Address>'.
							'</ShipFrom>'.
							'<Service>'.
								'<Code>'.urlencode($this->service).'</Code>'.
							'</Service>'.
							'<Package>'.
								$this->container.
								'<PackageWeight>'.
									'<UnitOfMeasurement>'.
										'<Code>'.urlencode($this->weightUnit).'</Code>'.
									'</UnitOfMeasurement>'.
									'<Weight>'.urlencode($this->pounds).'</Weight>'.
								'</PackageWeight>'.
							'</Package>'.
						'</Shipment>'. $this->customerClassification .
					'</RatingServiceSelectionRequest>';

        	//echo "<pre><b>UPS Request:</b><br>".htmlspecialchars($str)."</pre>";
		$buffer = "";
		$c = curl_init();
		
		if($settings["ProxyAvailable"] == "YES"){
			//curl_setopt($c, CURLOPT_VERBOSE, 1);
			if(defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5")){
				curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
			}
			curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
			if($settings["ProxyRequiresAuthorization"] == "YES"){
				curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
			}

			curl_setopt($c, CURLOPT_TIMEOUT, 120);
		}
				
		curl_setopt($c, CURLOPT_URL, $this->server);

	    curl_setopt($c, CURLOPT_SSL_VERIFYHOST, 0);
	   	curl_setopt($c, CURLOPT_POSTFIELDS, $str);
	    curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
		
		if( !ini_get('safe_mode') )
	   		set_time_limit(3000);
		curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
		curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
		curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
		$buffer = curl_exec($c);
				
		//echo "<pre><b>UPS answer:</b><br>".htmlspecialchars($buffer )."</pre>";
		if($buffer){
			$xmlParser = new XMLParser();
					
			$data = $xmlParser->parse($buffer);
				
			if($data["RatingServiceSelectionResponse"][0]["Response"][0]["ResponseStatusDescription"][0] == "Success" ){
				$a = $data["RatingServiceSelectionResponse"][0]["RatedShipment"][0];
				$code=$a["Service"][0]["Code"][0];
				if($code== $this->service){
					$ship_rate= $a["TotalCharges"][0]["MonetaryValue"][0];	
				}					
				return($ship_rate);			
			}
			else{ 
          	    return(false); 
        	}
		}
		else{ 
            return(false); 
        }
    }
    
	function getTrackingInfo($trackingNo){
		global $settings;
		$str = '<?xml version="1.0"?>'.
        			'<AccessRequest xml:lang="en-US">'.
        				'<AccessLicenseNumber>'.urlencode($this->accessKey).'</AccessLicenseNumber>'.
						 '<UserId>'.urlencode($this->user).'</UserId>'.
						 '<Password>'.urlencode($this->pass).'</Password>'.
					'</AccessRequest>'.
					'<?xml version="1.0"?>'.
						 '<TrackRequest xml:lang="en-US">'.
						 	'<Request>'.
							 	'<TransactionReference>'.
							 		'<CustomerContext>Example 2</CustomerContext>'.
							 		'<XpciVersion>1.0001</XpciVersion>'.
							 	'</TransactionReference>'.
							 	'<RequestAction>Track</RequestAction>'.
								'<RequestOption>none</RequestOption>'.
						 	'</Request>'.
						 	'<ReferenceNumber><Value>'.urlencode($trackingNo).'</Value></ReferenceNumber>'.
						 '</TrackRequest>';
		//echo "<pre><b>UPS Request:</b><br>".htmlspecialchars($str)."</pre>".$this->tracking_server;
		
		$buffer = "";
		$c = curl_init();
		
		if($settings["ProxyAvailable"] == "YES"){
			//curl_setopt($c, CURLOPT_VERBOSE, 1);
			if(defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5")){
				curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
			}
			curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
			if($settings["ProxyRequiresAuthorization"] == "YES"){
				curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
			}

			curl_setopt($c, CURLOPT_TIMEOUT, 120);
		}
				
		curl_setopt($c, CURLOPT_URL, $this->tracking_server);

	    curl_setopt($c, CURLOPT_SSL_VERIFYHOST, 0);
	    curl_setopt($c, CURLOPT_POSTFIELDS, $str);
	    curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);

		if( !ini_get('safe_mode') )
	   		set_time_limit(3000);
		curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
		curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
		curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
		$buffer = curl_exec($c);
		
		//echo "<pre><b>UPS answer:</b><br>".htmlspecialchars($buffer)."</pre>";
		
		
		if($buffer){					
			$xmlParser = new XMLParser();
			$tracking_data="";		
			$data = $xmlParser->parse($buffer);
				
			if($data["TrackResponse"][0]["Response"][0]["ResponseStatusCode"][0] == 1 and $data["TrackResponse"][0]["Response"][0]["ResponseStatusDescription"][0] == "Success"){
				$a = $data["TrackResponse"][0]["Shipment"][0];
				$tracking_data[shipping_method]=$a["Service"][0]["Description"][0];
				$tracking_data[pickup_date]=$a["PickupDate"][0];
				
				$tracking_data[pickup_date]= date('m-d-Y', strtotime($tracking_data[pickup_date]));
				
				if(isset($a["ScheduledDeliveryDate"][0])){
					$tracking_data[scheduled_delivery_date]=date('m-d-Y', strtotime($a["ScheduledDeliveryDate"][0]));
					$tracking_data[scheduled_delivery_time]=date('h:i:s A', strtotime($a["ScheduledDeliveryTime"][0]));		
				}
				
				$tracking_data[tracking_number]=$a["Package"][0]["TrackingNumber"][0];
				
				if(isset($tracking_data[rescheduled_delivery_date])){
					$tracking_data[rescheduled_delivery_date]=date('m-d-Y', strtotime($a["Package"][0]["RescheduledDeliveryDate"][0]));
				}
				
				$tracking_data[status_type_code]=$a["Package"][0]["Activity"][0]["Status"][0]["StatusType"][0]["Code"][0];
				$tracking_data["status_type_description"] = ucfirst($a["Package"][0]["Activity"][0]["Status"][0]["StatusType"][0]["Description"][0]);   
				
				$tracking_data[status_code]=$a["Package"][0]["Activity"][0]["Status"][0]["StatusCode"][0]["Code"][0];
				//$tracking_data[status_code]=$a["Package"][0]["Activity"][0]["Status"][0]["StatusCode"][0]["Code"][0];
				
				$tracking_data[activity_location] = ucfirst($a["Package"][0]["Activity"][0]["ActivityLocation"][0]["Address"][0]["AddressLine1"][0])." ".ucfirst($a["Package"][0]["Activity"][0]["ActivityLocation"][0]["Address"][0]["AddressLine2"][0]). " ".ucfirst($a["Package"][0]["Activity"][0]["ActivityLocation"][0]["Address"][0]["AddressLine3"][0]);
				
				$tracking_data[activity_location1] = $a["Package"][0]["Activity"][0]["ActivityLocation"][0]["Address"][0]["City"][0]. " ".$a["Package"][0]["Activity"][0]["ActivityLocation"][0]["Address"][0]["StateProvinceCode"][0]. " ".$a["Package"][0]["Activity"][0]["ActivityLocation"][0]["Address"][0]["PostalCode"][0]. " ".$a["Package"][0]["Activity"][0]["ActivityLocation"][0]["Address"][0]["CountryCode"][0];
				         
				$tracking_data[activity_date]=date('m-d-Y', strtotime($a["Package"][0]["Activity"][0]["Date"][0]));
				$tracking_data[activity_time]=date('h:i:s A', strtotime($a["Package"][0]["Activity"][0]["Time"][0]));
				
				if($a["Package"][0]["Message"][0]){
					$tracking_data[message]=$tracking_data[status_code]=$a["Package"][0]["Message"][0]["Description"][0];
				}
					
				$tracking_data[package_weight_unit]=$a["Package"][0]["PackageWeight"][0]["UnitOfMeasurement"][0]["Code"][0];
				$tracking_data[package_weight]=$a["Package"][0]["PackageWeight"][0]["Weight"][0];
				$tracking_data[shipment_weight_unit]=$a["ShipmentWeight"][0]["UnitOfMeasurement"][0]["Code"][0];
				$tracking_data[shipment_weight]=$a["ShipmentWeight"][0]["Weight"][0];
							
				return($tracking_data);			
			}
			else{ 
          	    return(false); 
        	}
		}
		else{ 
            return(false); 
        } 
		
	}
	
} 

