<?php
/* DataCash PHP API
   This module contains the log function used by all DataCash PHP API
   routines.

    $Id: DataCash_Logger.php,v 1.2.2.2 2006/06/05 16:56:30 victor Exp $
	
    Author: Dave MacRae

    Copyright: DataCash Group plc 2003

    Changelog:
		dem: 2002-05-11 Added check to stop file being opened if log level is to low
		dem: 2002-05-22 Added code to be manually switched for checking XML stuff
		dem: 2002-05-23 Added CVS ID tag and class logger
		dem: 2003-04-22 Automatically close the log file after writing to it. Not
		sure if this is the most efficient way to go.

*/

$CVSid = explode (" ", "$Id: DataCash_Logger.php,v 1.2.2.2 2006/06/05 16:56:30 victor Exp $");
$included_classes{basename($CVSid{1}, ".php,v")} = $CVSid{2};

function dc_log ($level, $message) {
  static $log_file_fp = FALSE;
  global $config;

  if (!$log_file_fp && $config->get("Configuration.logging") >= $level) {
    $log_file = $config->get("Configuration.logfile");
    if (!($log_file_fp = fopen($log_file, "ab"))) {
      print "<!-- Cannot open log file -->\n";
      return;
    }
  }

  if ($log_file_fp && $config->get("Configuration.logging") >= $level) {
    list($usec, $sec) = explode(" ", microtime());
    $usec = $usec * 1000;
    $now = gmdate ("Y d m H:i:s", $sec);
    $out_str = sprintf ("%s.%03d: %02d: %s\r\n", $now, $usec, $level, $message);
    fputs ($log_file_fp, $out_str);
  }

  if ($log_file_fp) {
    fclose($log_file_fp);
    $log_file_fp = FALSE;
  }
}
?>
