<?php 
	$payment_processor_id = 'directone';
	$payment_processor_name = 'DirectOne';
	$payment_processor_version = '1.0';
	$payment_processor_class = 'PAYMENT_DIRECTONE';
	$payment_processor_type = 'ipn';
	
	class PAYMENT_DIRECTONE extends PAYMENT_PROCESSOR
	{
		function PAYMENT_DIRECTONE()
		{
			parent::PAYMENT_PROCESSOR();
			$this->id = 'directone';
			$this->name = 'DirectOne';
			$this->version = '1.0';
			$this->class_name = 'PAYMENT_DIRECTONE';
			$this->type = 'ipn';
			$this->description = '';
			$this->post_url = 'https://vault.safepay.com.au/cgi-bin/';
			$this->steps = 2;
			$this->testMode = false;
			
			return $this;
		}
		
		function getPostUrl()
		{
			return $this->post_url . ($this->isTestMode() ? 'test' : 'make') . '_payment.pl';
		}
		
		function getPaymentForm($db)
		{
			$_pf = parent::getPaymentForm($db);
			global $settings;
			global $msg;
			
			$form = array();
			
			$notify_url = ($this->protocol == 'https' ? $settings['GlobalHttpsUrl'] : $settings['GlobalHttpUrl']) . '/' . $settings['INDEX'] . '?pcsid=' . session_id() . '&p=' . $this->payment_page . '&oa=' . ORDER_PROCESS_PAYMENT . '&reply=1&oid=' . $this->common_vars["order_id"]["value"] . '&vendor_name=&response_amount=';
			$return_url = ($this->protocol == 'https' ? $settings['GlobalHttpsUrl'] : $settings['GlobalHttpUrl']) . '/' . $settings['INDEX'] . '?pcsid=' . session_id() . '&p=' . $this->payment_page;
			
			$fields = array();
			
			$fields[] = array('type' => 'hidden', 'name' => 'vendor_name', 'value' => $this->settings_vars[$this->id.'_vendor_name']['value']);
			//$fields[] = array('type' => 'hidden', 'name' => 'x_amount', 'value' => number_format($this->common_vars['order_total_amount']['value'], 2, '.', ''));
			
			$fields[] = array('type' => 'hidden', 'name' => 'return_link_url', 'value' => $return_url);
			$fields[] = array('type' => 'hidden', 'name' => 'reply_link_url', 'value' => $notify_url);
			
			$fields[] = array('type' => 'hidden', 'name' => 'Order_Id', 'value' => $this->common_vars['order_id']['value']);
			$fields[] = array('type' => 'hidden', 'name' => 'Name', 'value' => $this->common_vars['billing_first_name']['value'] . ' ' . $this->common_vars['billing_last_name']['value']);
			$fields[] = array('type' => 'hidden', 'name' => 'Address', 'value' => $this->common_vars['billing_address']['value']);
			$fields[] = array('type' => 'hidden', 'name' => 'City', 'value' => $this->common_vars['billing_city']['value']);
			$fields[] = array('type' => 'hidden', 'name' => 'State', 'value' => $this->common_vars['billing_state']['value']);
			$fields[] = array('type' => 'hidden', 'name' => 'Postcode', 'value' => $this->common_vars['billing_zip']['value']);
			$fields[] = array('type' => 'hidden', 'name' => 'Country', 'value' => $this->common_vars['billing_country']['value']);
			$fields[] = array('type' => 'hidden', 'name' => 'Email', 'value' => $this->common_vars['billing_email']['value']);
			$fields[] = array('type' => 'hidden', 'name' => 'Phone', 'value' => $this->common_vars['billing_phone']['value']);
			
			$fields[] = array('type' => 'hidden', 'name' => 'information_fields', 'value' => 'Name,Address,City,State,Postcode,Country,Email,Phone,Order_Id');
			
			$db->query("SELECT * FROM " . DB_PREFIX . "orders_content WHERE oid ='" . $this->common_vars['order_oid']['value'] . "'");
			
			$subtotal = 0;
			$gst_exempt = '';
			while($db->moveNext())
			{
				$title = $db->col['title'] . ' (' . $db->col['product_id'] . ')';
				while (array_key_exists($title, $form))
				{
					if (preg_match('/_variation_#[0-9]+$/', $title))
					{
						$split = split('_variation_#', $title);
						$variation = end($split) + 1;
						$initial_title = $split[0];
						
						$title = $initial_title . '_variation_#' . $variation;
					}
					else
					{
						$title = $title.'_variation_#1';
					}
				}
				
				$price = round($db->col['price'], 2);
				
				if ($db->col['is_taxable'] == 'Yes' && $db->col['tax_rate'] > 0)
				{
					$rate = $db->col['tax_rate'] / 100;
					$price += $price * $rate;
				}
				
				$quantity = $db->col['quantity'];
				
				$form[$title] = array('quantity' => $quantity, 'price' => $price);
			}
			
			$tax = $this->common_vars['order_tax_amount']['value'];
			$shipping = $this->common_vars['order_shipping_amount']['value'] + ($this->common_vars["order_handling_separated"]["value"]=="yes" ? $this->common_vars["order_handling_amount"]["value"] : 0.00);
			$total = $this->common_vars['order_total_amount']['value'];
			
			$tax_rate = 0;
			if ($tax > 0 && ($total - $shipping - $tax))
			{
				$tax_rate = $tax / ($total - $shipping - $tax);
				$fields[] = array('type' => 'hidden', 'name' => 'gst_rate', 'value' => $tax_rate * 100);
				$fields[] = array('type' => 'hidden', 'name' => 'gst_added', 'value' => 'TRUE');
			}
			
			if ($shipping > 0)
			{
				$form['Shipping'] = array('quantity' => 1, 'price' => $shipping);
			}
			
			$form_total = 0;
			foreach($form as $f)
			{
				$form_total += $f['price'] * $f['quantity'];
			}
			
			if ($form_total != $total)
			{
				$fields[] = array('type' => 'hidden', 'name' => 'Order_' . $this->common_vars['order_id']['value'], 'value' => '1,' . $total);
			}
			else
			{
				foreach ($form as $key => $value)
				{
					$fields[] = array('type' => 'hidden', 'name' => $key, 'value' => $value['quantity'] . ',' . $value['price']);
				}
			}
			
			return $fields;
		}
		
		function getValidatorJS()
		{
			return "";
		}
		
		function isTestMode()
		{
			$this->testMode = ($this->settings_vars[$this->id.'_test']['value'] === 'TRUE');
			
			return $this->testMode;
		}
		
		function process($db, $user, $order, $post_form)
		{
			$post_form = $_REQUEST;
			
			if (array_key_exists('reply', $post_form) && array_key_exists('oid', $post_form) && array_key_exists('vendor_name', $post_form))
			{
				if ($post_form['reply'] == '1')
				{
					$ip = $_SERVER['REMOTE_ADDR'];
					$host = gethostbyaddr($ip);
					$order_id = preg_replace('/[^0-9]/', '', $post_form['order_id']);
					$response_amount = preg_replace('/[^0-9]/', '', $post_form['response_amount']) / 100;
					$vendor_name = preg_replace('/[ ]/', '', $post_form['vendor_name']);
					
					$response = 'Received DirectOne callback from ' . $ip . ' [' . $host . '] for $' . $response_amount . ' on ' . $vendor_name;
					
					$this->createTransaction($db, $user, $order, $response, '');
					$this->is_error = false;
					$this->error_message = '';
				}
				else
				{
					$this->is_error = true;
				}
			}
			else
			{
				$this->is_error = true;
			}
			
			if ($this->is_error)
			{
				$this->error_message = 'Transaction error. Please try again.';
				$this->logStart();
				$this->log(print_r($_REQUEST, true));
				$this->logFinish();
			}
			
			return !$this->is_error;
		}
	}
