<?php 
	$payment_processor_id = "linkpoint";
	$payment_processor_name = "LinkPoint.com";
	$payment_processor_version = "3.3";
	$payment_processor_class = "PAYMENT_LINKPOINT";
	$payment_processor_type = "cc";
	
	class PAYMENT_LINKPOINT extends PAYMENT_PROCESSOR{
		function PAYMENT_LINKPOINT(){
			parent::PAYMENT_PROCESSOR();
			$this->id = "linkpoint";
			$this->name = "LinkPoint.com";
			$this->version = "3.3";
			$this->class_name = "PAYMENT_LINKPOINT";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			$this->is_certificate = true;
			$this->certificate_path = "linkpoint/certificate.pem";
			$this->support_ccs = true;
			$this->need_cc_codes = true;
			return $this;
		}
		
		public function getPaymentForm($db){
			$fields = parent::getPaymentForm($db);
			return $fields;
		}
		
		public function isTestMode(){
			if($this->settings_vars[$this->id."_Mode"]["value"] != "LIVE"){
				$this->testMode = true;
			}
			else{
				$this->testMode = false;
			}
			return $this->testMode;
		}
		
		public function getVarStatus($custom1="", $custom2="", $custom3="", $order_status="", $payment_status=""){
			$var_status = array("1"=>false, "2"=>false, "3"=>false);
			if($custom1 == "PREAUTH" && $payment_status == "Pending"){
				$var_status[1] = array(
					"message"=>"<b>Please note: payment transaction is not completed yet and funds are not transfered to your LinkPoint merchant account. The reason is this transaction is PREAUTH transaction</b>",
					"executable"=>true,
					"link_caption"=>"To complete this transaction, click here"
				);
			}
			return $var_status;
		}
		
		public function process($db, $user, $order, $post_form){
			global $_SERVER;
			global $settings;
			//build XML request
			$xml = 
				'<order>'.
					'<merchantinfo>'.
						'<configfile>'.$this->settings_vars[$this->id."_Store_Number"]["value"].'</configfile>'.
					'</merchantinfo>'.
					'<billing>'.
						'<name>'.$post_form["cc_first_name"].' '.$post_form["cc_last_name"].'</name>'.
						'<company>'.$this->common_vars["billing_company"]["value"].'</company>'.
						'<address1>'.$this->common_vars["billing_address1"]["value"].'</address1>'.
						'<address2>'.$this->common_vars["billing_address2"]["value"].'</address2>'.
						'<city>'.$this->common_vars["billing_city"]["value"].'</city>'.
						'<state>'.$this->common_vars["billing_state"]["value"].'</state>'.
						'<zip>'.$this->common_vars["billing_zip"]["value"].'</zip>'.
						'<country>'.$this->common_vars["billing_country_iso_a2"]["value"].'</country>'.
						'<phone>'.$this->common_vars["billing_phone"]["value"].'</phone>'.
						'<email>'.$this->common_vars["billing_email"]["value"].'</email>'.
					'</billing>'.
					'<shipping>'.
						'<name>'.$this->common_vars["shipping_name"]["value"].'</name>'.
						'<address1>'.$this->common_vars["shipping_address1"]["value"].'</address1>'.
						'<address2>'.$this->common_vars["shipping_address2"]["value"].'</address2>'.
						'<city>'.$this->common_vars["shipping_city"]["value"].'</city>'.
						'<state>'.$this->common_vars["shipping_state"]["value"].'</state>'.
						'<zip>'.$this->common_vars["shipping_zip"]["value"].'</zip>'.
						'<country>'.$this->common_vars["shipping_country_iso_a2"]["value"].'</country>'.
					'</shipping>'.
					'<transactiondetails>'.
						'<oid>'.$this->common_vars["order_id"]["value"].'</oid>'.
						'<ip>'.$_SERVER["REMOTE_ADDR"].'</ip>'.
					'</transactiondetails>'.
					'<orderoptions>'.
						'<ordertype>'.$this->settings_vars[$this->id."_order_type"]["value"].'</ordertype>'.
						'<result>'.$this->settings_vars[$this->id."_Mode"]["value"].'</result>'.
					'</orderoptions>'.
					'<payment>'.
						'<chargetotal>'.number_format($this->common_vars["order_total_amount"]["value"], 2, ".", "").'</chargetotal>'.
					'</payment>'.
					'<creditcard>'.
						'<cardnumber>'.$post_form["cc_number"].'</cardnumber>'.
						'<cardexpmonth>'.round($post_form["cc_expiration_month"]).'</cardexpmonth>'.
						'<cardexpyear>'.substr($post_form["cc_expiration_year"], 2, 2).'</cardexpyear>'.
						((trim($post_form["cc_cvv2"]) == "")?"":
							'<cvmvalue>'.$post_form["cc_cvv2"].'</cvmvalue>'.
							'<cvmindicator>provided</cvmindicator>'
						).
					'</creditcard>'.
				'</order>';
			//prepare curl
			$_post_url = trim($this->url_to_gateway)==""?"https://secure.linkpt.net:1129/LSGSXML":trim($this->url_to_gateway);
			$_cert_path = $settings["GlobalServerPath"]."/content/engine/payment/".$this->certificate_path;
			
			$c = curl_init($_post_url);
			
			if($settings["ProxyAvailable"] == "YES"){
				//curl_setopt($c, CURLOPT_VERBOSE, 1);
				if(defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5")){
					curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
				}
				curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
				if($settings["ProxyRequiresAuthorization"] == "YES"){
					curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
				}

				curl_setopt($c, CURLOPT_TIMEOUT, 120);
			}
			
			curl_setopt($c, CURLOPT_POST, 1); 
			curl_setopt($c, CURLOPT_POSTFIELDS, $xml);
			curl_setopt($c, CURLOPT_SSLCERT, $_cert_path);
			curl_setopt($c, CURLOPT_SSL_VERIFYHOST, 0);

			curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
			curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
			curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
			$buffer = curl_exec($c);
			
			//check for a empty buffer
			if(strlen($buffer) < 2){
				$buffer = "<r_approved>FAILURE</r_approved><r_error>Could not connect to the LinkPoint server. Please try again.</r_error>";
			}
			//parse buffer
			preg_match_all("/<(.*?)>(.*?)\</", $buffer, $out, PREG_SET_ORDER);
			$n = 0;
			$result = array();
			$response = "";
			while(isset($out[$n])){
				$result[$out[$n][1]] = strip_tags($out[$n][0]);
				$response.=$out[$n][1]." = ".strip_tags($out[$n][0])."\n";
				$n++; 
			}
			//check response status
			if(!array_key_exists("r_approved", $result)){
				$result["r_approved"] = "FAILURE";
				if(!array_key_exists("r_error", $result)){
					$result["r_error"] = "Internal Transaction Error. Please try again";
				}
			}
			switch($result["r_approved"]){
				//transaction completed
				case "APPROVED" : {
					$this->createTransaction($db, $user, $order, 
						"ORDER TYPE: ".$this->settings_vars[$this->id."_order_type"]["value"]."\n\n".$response, "", 
						//custom1,2,3
						$this->settings_vars[$this->id."_order_type"]["value"], 
						($this->settings_vars[$this->id."_order_type"]["value"] != "SALE" ? ($post_form["cc_number"]."|".round($post_form["cc_expiration_month"])."|".substr($post_form["cc_expiration_year"], 2, 2)) : ""),
						""
					);
					if($this->support_ccs && $this->enable_ccs){
						$card_data = array(
							"fn"=>$post_form["cc_first_name"],
							"ln"=>$post_form["cc_last_name"],
							"ct"=>$post_form["cc_type"],
							"cc"=>$post_form["cc_number"],				
							"em"=>$post_form["cc_expiration_month"], 
							"ey"=>$post_form["cc_expiration_year"]
						);
						$this->saveCCdata($db, $order, $card_data, base64_decode($settings["SecurityCCSCertificate"]));
					}
					return $this->settings_vars[$this->id."_order_type"]["value"] == "SALE" ? "Received" : "Pending";
					break;
				}
				//transaction error
				default : {
					$this->is_error = true;
					$this->error_message = PAYMENT_TRANSACTION_ERROR_TEXT.$result["r_error"];
					break;
				}
			}
			//complete process
			return !$this->is_error;
		}
		
		public function processCustom($db, $custom_id, $order_id){
			global $settings;
			$this->is_error = false;
			switch($custom_id){
				//run post auth
				case "1" : {
					$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid='".$order_id."'");
					if($db->moveNext()){
						$order_data = $db->col;
						
						//check is transaction completed
						if($order_data["custom1"] != "PREAUTH"){
							$this->is_error = true;
							$this->error_message = "Transaction already completed";
							return false;
						}
						
						//build XML
						$card_info = explode("|", $order_data["custom2"]);
						$xml = 
							'<order>'.
								'<merchantinfo>'.
									'<configfile>'.$this->settings_vars[$this->id."_Store_Number"]["value"].'</configfile>'.
								'</merchantinfo>'.
								'<orderoptions>'.
									'<ordertype>POSTAUTH</ordertype>'.
									'<result>'.$this->settings_vars[$this->id."_Mode"]["value"].'</result>'.
								'</orderoptions>'.
								'<payment>'.
									'<chargetotal>'.number_format($order_data["total_amount"], 2, ".", "").'</chargetotal>'.
								'</payment>'.
								'<transactiondetails>'.
									'<oid>'.$order_data["order_num"].'</oid>'.
									'<ip>'.$_SERVER["REMOTE_ADDR"].'</ip>'.
								'</transactiondetails>'.
								'<creditcard>'.
									'<cardnumber>'.$card_info[0].'</cardnumber>'.
									'<cardexpmonth>'.$card_info[1].'</cardexpmonth>'.
									'<cardexpyear>'.$card_info[2].'</cardexpyear>'.
								'</creditcard>'.
							'</order>';
						
								
						//send data to a server
						$_post_url = trim($this->url_to_gateway)==""?"https://secure.linkpt.net:1129/LSGSXML":trim($this->url_to_gateway);
						$_cert_path = $settings["GlobalServerPath"]."/content/engine/payment/".$this->certificate_path;
			
						if( !ini_get('safe_mode') )
							set_time_limit(300);
						
						$c = curl_init($_post_url);
						
						if($settings["ProxyAvailable"] == "YES"){
							//curl_setopt($c, CURLOPT_VERBOSE, 1);
							if(defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5")){
								curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
							}
							curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
							if($settings["ProxyRequiresAuthorization"] == "YES"){
								curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
							}

							curl_setopt($c, CURLOPT_TIMEOUT, 120);
						}
						
						curl_setopt($c, CURLOPT_POST, 1); 
						curl_setopt($c, CURLOPT_POSTFIELDS, $xml);
						curl_setopt($c, CURLOPT_SSLCERT, $_cert_path);
						curl_setopt($c, CURLOPT_SSL_VERIFYHOST, 0);

						curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
						curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
						curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
						curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
						$buffer = curl_exec($c);
			
						//check for a empty buffer
						if(strlen($buffer) < 2){
							$buffer = "<r_approved>FAILURE</r_approved><r_error>Could not connect to the LinkPoint server. Please try again.</r_error>";
						}
						//parse buffer
						preg_match_all("/<(.*?)>(.*?)\</", $buffer, $out, PREG_SET_ORDER);
						$n = 0;
						$result = array();
						$response = "";
						while(isset($out[$n])){
							$result[$out[$n][1]] = strip_tags($out[$n][0]);
							$response.=$out[$n][1]." = ".strip_tags($out[$n][0])."\n";
							$n++; 
						}
						//check response status
						if(!array_key_exists("r_approved", $result)){
							$result["r_approved"] = "FAILURE";
							if(!array_key_exists("r_error", $result)){
								$result["r_error"] = "Internal Transaction Error. Please try again";
							}
						}
						switch($result["r_approved"]){
							//transaction completed
							case "APPROVED" : {
								$db->reset();
								$db->assignStr("payment_status", "Received");
								$db->update(DB_PREFIX."orders", "WHERE oid='".$order_id."'");
								
								$user = new tmp_object();
								$user->id = $order_data["uid"];
								
								$order = new tmp_object();
								$order->oid = $order_data["oid"];
								$order->subtotalAmount = $order_data["subtotal_amount"];
								$order->totalAmount = $order_data["total_amount"];
								$order->shippingAmount = $order_data["shipping_amount"];
								$order->taxAmount = $order_data["tax_amount"];
								
								$this->createTransaction($db, $user, $order, 
									"ORDER TYPE: POSTAUTH\n\n".$response, 
									"", "PostAuth", "", ""
								);
								
								break;
							}
							//transaction error
							default : {
								$this->is_error = true;
								$this->error_message = PAYMENT_TRANSACTION_ERROR_TEXT.$result["r_error"];
								break;
							}
						}
					}
					break;
				}
				default : {
					$this->is_error = true;
					$this->error_message = "Incorrect action ID";
					break;
				}
			}
			return !$this->is_error;
		}
	}
?>
