<?php 
	$payment_processor_id = "paypalipn";
	$payment_processor_name = "PayPal Website Payments Standard";
	$payment_processor_version = "3.3";
	$payment_processor_class = "PAYMENT_PAYPALIPN";
	$payment_processor_type = "ipn";
	
	class PAYMENT_PAYPALIPN extends PAYMENT_PROCESSOR{
		function PAYMENT_PAYPALIPN(){
			parent::PAYMENT_PROCESSOR();
			$this->id = "paypalipn";
			$this->name = "PayPal Website Payments Standard";
			$this->version = "3.3";
			$this->class_name = "PAYMENT_PAYPALIPN";
			$this->type = "ipn";
			$this->description = "";
			$this->post_url = "https://www.paypal.com/cgi-bin/webscr";
			$this->steps = 2;
			$this->possible_payment_delay = true;
			$this->possible_payment_delay_timeout = 10; // seconds
			return $this;
		}
		
		//redeclare getPaymentForm 
		function getPaymentForm($db){
			global $_SESSION;
			global $settings, $order, $url_dinamic;
			global $msg;
			
			$_pf = parent::getPaymentForm($db);
			
			$notify_url = ($this->protocol=="https"?$settings["GlobalHttpsUrl"]:$settings["GlobalHttpUrl"])."/".$settings["INDEX"]."?pcsid=".session_id()."&p=".$this->payment_page."&oa=".ORDER_PROCESS_PAYMENT;
			$return_url = $url_dinamic."p=completed";

			// wmw 04/05/05 Added to get phone number fields for PayPal
			if ($this->common_vars["billing_country_iso_a2"]["value"] == "US") {
				$pp_phone = ereg_replace("[-\(\)\. ]","",$this->common_vars["billing_phone"]["value"]);
				$pp_phone_a = substr($pp_phone,0,3);
				$pp_phone_b = substr($pp_phone,3,3);
				$pp_phone_c = substr($pp_phone,6,4);
			} 
			else {
				$pp_phone_a = "";
				$pp_phone_b = "";
				$pp_phone_c = "";
			}
			// END wmw 04/05/05
				
			
			$fields = array();
			
			$fields[] = array("type"=>"hidden", "name"=>"business", "value"=>$this->settings_vars[$this->id."_business"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"receiver_email", "value"=>$this->settings_vars[$this->id."_business"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"item_name", "value"=>$settings["CompanyName"].' Order #'.$this->common_vars["order_id"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"item_number", "value"=>$this->common_vars["order_id"]["value"]);
			
			$fields[] = array("type"=>"hidden", "name"=>"first_name", "value"=>$this->common_vars["billing_first_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"last_name", "value"=>$this->common_vars["billing_last_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"address1", "value"=>$this->common_vars["billing_address1"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"address2", "value"=>$this->common_vars["billing_address2"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"city", "value"=>$this->common_vars["billing_city"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"state", "value"=>$this->common_vars["billing_state_abbr"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"zip", "value"=>$this->common_vars["billing_zip"]["value"]);
			
			$fields[] = array("type"=>"hidden", "name"=>"paymentaction", "value"=>strtolower($this->settings_vars[$this->id."_Payment_Action"]["value"]));
			$fields[] = array("type"=>"hidden", "name"=>"currency_code", "value"=>$this->settings_vars[$this->id."_currency_code"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"cmd", "value"=>"_xclick");
			$fields[] = array("type"=>"hidden", "name"=>"bn", "value"=>"PCart_cart_IPN_US");
			
			$fields[] = array("type"=>"hidden", "name"=>"quantity", "value"=>"1");
			$fields[] = array("type"=>"hidden", "name"=>"invoice", "value"=>$this->common_vars["order_id"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"custom", "value"=>$this->common_vars["order_id"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"shipping", "value"=>"0.00");
			$fields[] = array("type"=>"hidden", "name"=>"amount", "value"=>round($this->common_vars["order_total_amount"]["value"], 2));
			
			$fields[] = array("type"=>"hidden", "name"=>"address_name", "value"=>$this->common_vars["shipping_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"address_street", "value"=>trim($this->common_vars["shipping_address"]["value"]));
			$fields[] = array("type"=>"hidden", "name"=>"address_city", "value"=>$this->common_vars["shipping_city"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"address_state", "value"=>$this->common_vars["shipping_state_abbr"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"address_zip", "value"=>$this->common_vars["shipping_zip"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"address_country", "value"=>$this->common_vars["shipping_country"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"address_status", "value"=>"unconfirmed");
			
			$fields[] = array("type"=>"hidden", "name"=>"country", "value"=>$this->common_vars["billing_country_iso_a2"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"email", "value"=>$this->common_vars["billing_email"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"no_shipping", "value"=>"2");
			
			$fields[] = array("type"=>"hidden", "name"=>"payer_id", "value"=>$this->common_vars["customer_id"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"notify_version", "value"=>"1.6");
			$fields[] = array("type"=>"hidden", "name"=>"notify_url", "value"=>$notify_url);
			$fields[] = array("type"=>"hidden", "name"=>"return", "value"=>$return_url);
			//$fields[] = array("type"=>"hidden", "name"=>"bn", "value"=>"IPN");
			$fields[] = array("type"=>"hidden", "name"=>"cancel_return", "value"=>(($this->protocol=="https"?$settings["GlobalHttpsUrl"]:$settings["GlobalHttpUrl"])."/".$settings["INDEX"]."?pcsid=".session_id()."&p=".$this->payment_page));

			return $fields;
		}
		
		function getValidatorJS(){
			return "";
		}
		
		function isTestMode(){
			if($this->settings_vars[$this->id."_mode"]["value"] == "TEST"){
				$this->testMode = true;
				$this->post_url = "https://www.sandbox.paypal.com/cgi-bin/webscr";
			}
			else{
				$this->testMode = false;
				$this->post_url = "https://www.paypal.com/cgi-bin/webscr";
			}
			return $this->testMode;
		}
		
		function getPostUrl(){
			if(trim($this->url_to_gateway) != ""){
				return trim($this->url_to_gateway);
			}
			else{
				return $this->post_url;
			}
		}
		
		function process($db, $user, $order, $post_form){
			global $_POST;
			global $settings;
			
			$this->log(print_r($_POST, 1));
			//check payment status				
			if((trim(strtolower($post_form["payment_status"])) == "completed") || (trim(strtolower($post_form["payment_status"])) == "pending")){
				
				//reinsure all is OK - verify request
				$post_data = 'cmd=_notify-validate';
				reset($post_form);
				foreach($_POST as $var_name=>$var_value){
					$post_data .= "&".$var_name."=".urlencode($var_value);
				}
				$this->log($post_data);
				//https://www.sandbox.paypal.com/cgi-bin/webscr
				$this->post_url = $this->getPostUrl();
				
				//send data back to server
				$c = curl_init();
				
				if($settings["ProxyAvailable"] == "YES"){
					//curl_setopt($c, CURLOPT_VERBOSE, 1);
					if(defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5")){
						curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
					}
					curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
					if($settings["ProxyRequiresAuthorization"] == "YES"){
						curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
					}

					curl_setopt($c, CURLOPT_TIMEOUT, 120);
				}
			
				curl_setopt($c, CURLOPT_URL, trim($this->post_url));
				curl_setopt($c, CURLOPT_FAILONERROR, 1);
				curl_setopt($c, CURLOPT_FOLLOWLOCATION, 1);
				curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($c, CURLOPT_POST, 1);
				curl_setopt($c, CURLOPT_POSTFIELDS, $post_data);
			
				curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
				curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
				curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
				$buffer = curl_exec($c);
				
				$this->log($buffer);
				
				$this->logStart();
				$this->log($buffer);
				$this->logFinish();
				
				curl_close($c);
				
				//check verification value
				if(trim(strtolower($buffer)) == "verified"){
					reset($post_form);
					$response = "Verification Status: ".$buffer."\n";
					foreach($post_form as $var_name=>$var_value){
						$response.=$var_name." = ".$var_value."\n";
						if($var_name == "auth_id")
							$transaction_id = $var_value;
						if($var_name == "payment_status")
							$payment_status = $var_value;	
						if($var_name == "pending_reason")	
							$PendingReason = $var_value;
					}					
					$this->createTransaction($db, $user, $order, $response, "", $PendingReason, "", 0, $transaction_id);
					$this->is_error = false;
					$this->error_message = "";
					return $payment_status;
				}
				else{
					$this->is_error = true;
					$this->error_message = "Can't complete your order. PayPal payment is not completed yet.";
				}
			}
			else{
				$this->is_error = true;
				$this->error_message = "An error occurred while PayPal was processing your order. It will be investigated by a human at the earliest opportunity. We apologise for any inconvenience.";
			}

			return !$this->is_error;
		}
	}
