<?php
/**
 * Handle user signup
 */

if (!defined("ENV")) exit();

if ($user->auth_ok)
{		
	//assign user name
	view()->assign("user_fname", $user->fname);
	view()->assign("user_lname", $user->lname);
	//set to let template know is there items in the cart
}
else
{
	//assign actions IDs
	view()->assign("USER_SIGNUP", USER_SIGNUP);
	
	//country / state data
	require_once("content/classes/class.regions.php");
	$regions = new Regions($db);
	view()->assign("countries_states", json_encode($regions->getCountriesStatesForSite()));

	//check shipping
	$sc = getShippingCountries($db);
	if (is_array($sc))
	{
		view()->assign("ship2countries", in_array(0, $sc) ? "all" : $sc);
	}
	else
	{
		view()->assign("ship2countries", "all");
	}
	
	//check is there registration error on wrong attempt
	view()->assign("is_user_errors", ($ua=USER_SIGNUP) && ($user->is_error)?"yes":"no");
	if (($ua=USER_SIGNUP) && ($user->is_error))
	{
		$user_errors = "";
		reset($user->errors);
		while (list($key, $value) = each($user->errors))
		{
			$user_errors.='<li>'.$value.'</li>';
		}
		view()->assign("user_errors", $user_errors);
		
		view()->assign("userErrors", $user->errors);
	}
	
	//check / create form data array 
	$form = isset($_POST["form"]) ? $_POST["form"] : array("email_newsletters"=>"No", "email_updates"=>"Yes");
	$form = is_array($form) ? $form : array("email_newsletters"=>"No", "email_updates"=>"Yes");
	
	$custom_field = isset($_POST["custom_field"]) ? $_POST["custom_field"] : array();
	view()->assign("cf_billing", $cf_billing = $custom_fields->getCustomFields("billing", $custom_field, 0, 0));
	view()->assign("cf_signup", $cf_signup = $custom_fields->getCustomFields("signup", $custom_field, 0, 0));
	view()->assign("cf_account", $cf_account = $custom_fields->getCustomFields("account", $custom_field, 0, 0));
	
	view()->assign("form", $form);
}

//finally, join template
view()->assign("body", "templates/pages/account/signup.html");
